;;; Sierra Script 1.0 - (do not remove this comment)
(script# 301)
(include sci.sh)
(use Main)
(use Class_255_0)
(use n802)
(use RegionPath)
(use n962)
(use n982)
(use Avoid)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	Water 0
	EgoWaterViewer 1
	bikini3Lady 2
	bikini4Lady 3
)

(local
	local0
	[local1 113] = [32767 7 273 117 104 132 48 235 32767 5 72 104 135 104 325 184 32767 4 76 95 128 103 325 178 32767 3 -5 90 325 100 32767 2 -5 100 180 160 325 185 32767 12 -5 170 175 156 325 128 32767 13 -5 128 325 106 32767 24 -5 116 184 111 155 72 -5 130 32767 13 325 106 -5 128 32767 12 325 128 175 156 -5 170 32767 2 325 150 -5 100 32767 3 325 100 -5 90 32767 4 325 178 128 103 76 95 32767 5 325 184 135 104 72 104 32767 7 48 235 104 132 273 117 -32768]
)
(procedure (localproc_0012 &tmp temp0 temp1)
	(= temp1 (& (= temp0 (GetTime 3)) $001f))
	(FormatPrint
		301
		22
		(& (>> temp0 $0005) $000f)
		(+ (if (< temp1 29) global142 else 0) temp1)
		(- (>> temp0 $0009) 60)
	)
)

(instance EgoWaterViewer of Code
	(properties)
	
	(method (doit &tmp gEgoView)
		(if (== (= gEgoView (gEgo view?)) 206)
			(gEgo observeControl: 4096 2048)
			(if (& (proc802_0 gEgo) $1000)
				(if (not local0) (Print 301 0) (= local0 1))
			else
				(= local0 0)
			)
		else
			(gEgo
				ignoreControl: 4096 2048
				view:
					(switch (gEgo onControl: 1)
						(1024 216)
						(2048 215)
						(4096 214)
						(else 
							(if (proc999_5 gEgoView 214 215) 200 else gEgoView)
						)
					)
			)
			(if
			(and (!= gEgoView (gEgo view?)) (gEgo mover?))
				((gEgo mover?) init:)
			)
		)
	)
	
	(method (dispose)
		(gEgo viewer: 0)
		(super dispose:)
	)
)

(instance Water of Rgn
	(properties)
	
	(method (init)
		(Load rsVIEW 217)
		(Load rsVIEW 216)
		(Load rsVIEW 215)
		(Load rsVIEW 214)
		(Load rsVIEW 702)
		(Load rsVIEW 202)
		(Load rsVIEW 902)
		(super init: &rest)
		(gEgo viewer: EgoWaterViewer)
		(closeUpView init:)
		(if (not script) (self setScript: beachWalkerScript))
		(if (IsObject (script register?))
			((script register?) init: setMotion: beachWalkerPath)
		)
		(if (not (gGame script?))
			(gGame setScript: musicScript)
		)
	)
	
	(method (dispose)
		(EgoWaterViewer dispose:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'swim')
				(if (== (gEgo view?) 206)
					(Print 301 1)
				else
					(Print 301 2)
				)
			)
			(
			(or (Said 'climb') (Said 'get/sand,plant,water')) (PrintDontNeed))
			((Said 'walk,enter,go<in,in/bush') (Print 301 3))
			((Said 'look>')
				(cond 
					((Said '/palm,bush,plant,vegetation') (Print 301 4))
					((Said '/water,bay,lagoon') (Print 301 5))
					((Said '<up') (Print 301 6))
					((Said '[<at,down,in][/beach,sand,floor]')
						(if (proc999_5 (gEgo view?) 317 216 215)
							(Print 301 7)
						else
							(switch (Random 1 3)
								(1 (Print 301 8))
								(2 (Print 301 9))
								(3 (Print 301 10))
							)
						)
					)
					((Said '[<at,up][/sky]')
						(switch (Random 1 2)
							(1 (Print 301 11))
							(2 (Print 301 12))
						)
					)
				)
			)
			((Said 'kiss,suck,fuck,touch/babe,cunt,boob') (Print 301 13))
		)
	)
	
	(method (newRoom newRoomNumber)
		(if
			(not
				(= keep
					(proc999_5 newRoomNumber 1 2 3 4 5 7 12 13 9 24 8 16)
				)
			)
			(gGame setScript: 0)
		)
		(= initialized 0)
		(super newRoom: newRoomNumber &rest)
	)
	
	(method (notify param1 param2 &tmp temp0)
		(switch param1
			(0
				(= temp0 0)
				(while (< temp0 (- argc 2))
					((Clone param2)
						x: [param2 (++ temp0)]
						y: [param2 (++ temp0)]
						loop: [param2 (++ temp0)]
						init:
					)
				)
			)
			(1
				(beachWalkerScript register?)
				(return)
			)
		)
	)
)

(instance musicScript of Script
	(properties)
	
	(method (doit)
		(if
			(and
				(== state 0)
				(== (gIceGlobalSound prevSignal?) -1)
			)
			(= cycles 1)
		)
		(super doit:)
	)
	
	(method (dispose)
		(gIceGlobalSound stop:)
		(super dispose:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gIceGlobalSound number: 5 loop: 2 play:)
			)
			(1
				(gIceGlobalSound number: 4 loop: -1 play:)
			)
		)
	)
)

(instance closeUpView of View
	(properties
		y 85
		x 265
		loop 4
	)
	
	(method (init)
		(super init:)
		(self hide: setPri: 15)
	)
	
	(method (show param1)
		(self view: param1 setLoop: 4)
		(super show:)
	)
)

(instance bikini3Lady of Act
	(properties
		view 702
	)
	
	(method (init)
		(super init:)
		(self
			setAvoider: Avoid 1
			ignoreHorizon:
			setCycle: Walk
			observeControl: 2048
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((proc982_0 self))
			((Said 'look[<at][/babe[<native]]')
				(closeUpView show: view)
				(Animate (gCast elements?) 0)
				(Print 301 14)
				(closeUpView hide:)
				(pEvent claimed: 1)
			)
			((Said 'whistle') (Print 301 15))
			((Said 'ask<out/babe') (Print 301 16))
			(
			(Said '[/bitch,cunt,boob,brunette,babe[<native]]>')
				(cond 
					((Said 'ask//date') (localproc_0012))
					((Said 'ask//time') (Print 301 17))
					((Said 'chase') (Print 301 18))
					((Said 'address') (Print 301 19))
					((Said 'kiss,suck,fuck,touch')
						(if (> (gEgo distanceTo: self) 50)
							(Print 301 20)
						else
							(proc962_0 self 352)
						)
					)
				)
			)
		)
	)
)

(instance bikini4Lady of Act
	(properties
		view 202
	)
	
	(method (init)
		(super init:)
		(self
			setAvoider: Avoid 1
			ignoreHorizon:
			setCycle: Walk
			observeControl: 2048
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((proc982_0 self))
			((Said 'look[<at][/blond,babe[<blond]]')
				(closeUpView show: view)
				(Animate (gCast elements?) 0)
				(Print 301 21)
				(closeUpView hide:)
				(pEvent claimed: 1)
			)
			((Said 'whistle') (Print 301 15))
			((Said 'ask<out/babe') (Print 301 16))
			((Said '[/bitch,cunt,boob,blond,babe[<blond]]>')
				(cond 
					((Said 'ask//date') (localproc_0012))
					((Said 'ask//time') (Print 301 17))
					((Said 'chase') (Print 301 18))
					((Said 'address') (Print 301 19))
					((Said 'kiss,suck,fuck,touch')
						(if (> (gEgo distanceTo: self) 50)
							(Print 301 20)
						else
							(proc962_0 self 353)
						)
					)
				)
			)
		)
	)
)

(instance beachWalkerPath of RegionPath
	(properties
		value 29
		endType 0
		theRegion 301
	)
	
	(method (nextRoom)
		(if
			(and
				(== (self at: (+ 2 value)) 3)
				(== gCurRoomNum 3)
				(gRoom notify: 0)
			)
			(repeat
				(= value (- value 2))
				(if (== (self at: (+ 1 value)) 32767) (break))
			)
		)
		(super nextRoom: &rest)
	)
	
	(method (at param1)
		(return [local1 param1])
	)
)

(instance beachWalkerScript of Script
	(properties)
	
	(method (changeState newState &tmp theRegister)
		(switch (= state newState)
			(0
				(= theRegister
					(switch (Random 2 3)
						(2 bikini3Lady)
						(3 bikini4Lady)
					)
				)
				(beachWalkerPath value: -1)
				(if (IsObject register) (register dispose:))
				(if (== theRegister register)
					(self init:)
				else
					((= register theRegister)
						init:
						setMotion: beachWalkerPath self
					)
				)
			)
			(1 (self init:))
		)
	)
)
