;;; Sierra Script 1.0 - (do not remove this comment)
(script# 42)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Rev)
(use Grooper)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	bHatchTubeRm 0
)

(instance bHatchTubeRm of Rm
	(properties
		picture 42
		north 41
		east 33
		west 35
	)
	
	(method (init)
		(super init:)
		(gEgo init:)
		(eastDoor init:)
		(westDoor init:)
		(self
			setRegions: 314
			setScript:
				(switch gPrevRoomNum
					(east cameFromEastScript)
					(west cameFromWestScript)
					(north cameFromNorthScript)
				)
				self
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room,scene]') (Print 42 0))
		)
	)
	
	(method (cue)
		(self setScript: roomControlScript)
	)
	
	(method (newRoom newRoomNumber)
		(gEgo setPri: -1 setLoop: -1 setCycle: Walk)
		(HandsOn)
		(super newRoom: newRoomNumber)
	)
)

(instance cameFromNorthScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(if (gEgo looper?) ((gEgo looper?) dispose:))
				(gEgo
					view: 42
					posn: 124 27
					setCycle: Rev
					setLoop: 3
					setMotion: MoveTo 124 95 self
				)
			)
			(1
				(gEgo
					view: 232
					setCycle: Walk
					heading: 0
					observeControl: -32768
					setLoop: -1
					setLoop: Grooper
				)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance cameFromEastScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					loop: 1
					cel: 7
					posn: 159 104
					setMotion: MoveTo 144 104 self
				)
				(eastDoor posn: 151 51 setMotion: MoveTo 151 101 self)
			)
			(1)
			(2
				(eastDoor stopUpd:)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance cameFromWestScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					loop: 0
					cel: 7
					posn: 89 104
					setMotion: MoveTo 104 104 self
				)
				(westDoor posn: 95 51 setMotion: MoveTo 95 101 self)
			)
			(1)
			(2
				(westDoor stopUpd:)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance roomControlScript of Script
	(properties)
	
	(method (doit)
		(cond 
			((< (gEgo x?) 104) (client setScript: goWestScript))
			((> (gEgo x?) 144) (client setScript: goEastScript))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'go,climb[<up][/ladder]') (gEgo setScript: climbStairsScript) (self dispose:))
		)
	)
)

(instance goWestScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo 89 102 self
				)
				(westDoor setMotion: MoveTo 95 51 self)
			)
			(1)
			(2
				(gEgo illegalBits: -32768 ignoreActors: 0)
				(gRoom newRoom: (gRoom west?))
			)
		)
	)
)

(instance goEastScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo 159 102 self
				)
				(eastDoor setMotion: MoveTo 151 51 self)
			)
			(1)
			(2
				(gEgo illegalBits: -32768 ignoreActors: 0)
				(gRoom newRoom: (gRoom east?))
			)
		)
	)
)

(instance climbStairsScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo setMotion: MoveTo 124 97 self)
			)
			(1
				(gEgo
					view: 42
					heading: 0
					ignoreControl: -32768
					setMotion: MoveTo 124 27 self
				)
			)
			(2
				(gRoom newRoom: (gRoom north?))
			)
		)
	)
)

(instance eastDoor of Act
	(properties
		y 101
		x 151
		view 41
	)
	
	(method (init)
		(super init:)
		(self setPri: 14 ignoreActors: 1 ignoreControl: -32768)
	)
	
	(method (stopUpd)
		(super stopUpd:)
		(doorSound number: (DecideSound 19) play:)
	)
	
	(method (setMotion)
		(super setMotion: &rest)
		(doorSound number: (DecideSound 13) play:)
	)
)

(instance westDoor of Act
	(properties
		y 101
		x 95
		view 41
		cel 1
	)
	
	(method (init)
		(super init:)
		(self setPri: 14 ignoreActors: 1 ignoreControl: -32768)
	)
	
	(method (stopUpd)
		(super stopUpd:)
		(doorSound number: (DecideSound 19) play:)
	)
	
	(method (setMotion)
		(super setMotion: &rest)
		(doorSound number: (DecideSound 13) play:)
	)
)

(instance doorSound of Sound
	(properties
		number 19
		priority 2
	)
)
