;;; Sierra Script 1.0 - (do not remove this comment)
(script# 28)
(include sci.sh)
(use Main)
(use Class_255_0)
(use CyclingProp)
(use Cycle)
(use Game)
(use User)
(use Feature)
(use Obj)

(public
	bridgeRm 0
)

(instance bridgeRm of Rm
	(properties
		picture 28
		south 25
	)
	
	(method (init)
		(super init:)
		(gIceGlobalSound number: 90 loop: -1 play:)
		(self overlay: 128 setRegions: 314)
		(water1CP init:)
		(water2CP init:)
		(water3CP init:)
		(radarCP init:)
		(reflectionCP init:)
		(reflectionCP1 init:)
		(reflectionCP2 init:)
		(gAddToPics
			add: destroyer1PV destroyer2PV
			eachElementDo: #init
			doit:
		)
		(gEgo
			init:
			ignoreActors: 1
			posn: 83 80
			view: 228
			loop: 0
			cel: 0
		)
		(captainP init: setScript: captainsScript)
		(binocularV init: hide:)
		(HandsOn)
		(User canControl: 0)
	)
	
	(method (dispose)
		(DisposePrintDlg)
		(gEgo ignoreActors: 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room,scene,bay,water]') (Print 28 0))
			(
				(or
					(Said 'use,get,(look[<at])/binoculars')
					(Said 'binoculars<use')
				)
				(Print 28 1)
			)
		)
	)
)

(instance water1CP of CyclingProp
	(properties
		y 142
		x 259
		view 28
		loop 2
	)
)

(instance water2CP of CyclingProp
	(properties
		y 142
		x 259
		view 28
		loop 3
	)
)

(instance water3CP of CyclingProp
	(properties
		y 92
		x 209
		view 28
		loop 1
	)
)

(instance radarCP of CyclingProp
	(properties
		y 77
		x 37
		view 28
		priority 15
	)
)

(instance reflectionCP of CyclingProp
	(properties
		y 41
		x 197
		view 28
		loop 4
	)
)

(instance reflectionCP1 of CyclingProp
	(properties
		y 38
		x 246
		view 28
		loop 4
	)
)

(instance reflectionCP2 of CyclingProp
	(properties
		y 39
		x 254
		view 28
		loop 4
	)
)

(instance destroyer1PV of PV
	(properties
		y 36
		x 304
		view 128
	)
)

(instance destroyer2PV of PV
	(properties
		y 36
		x 286
		view 128
		cel 1
	)
)

(instance captainP of Prop
	(properties
		y 80
		x 128
		view 228
		loop 1
	)
	
	(method (init)
		(gIceKeyDownHandler add: self)
		(gIceMouseDownHandler add: self)
		(self ignoreActors: 1)
		(super init: &rest)
	)
	
	(method (dispose)
		(gIceKeyDownHandler delete: self)
		(gIceMouseDownHandler delete: self)
		(super dispose: &rest)
	)
)

(instance binocularV of View
	(properties
		y 50
		x 70
		view 128
	)
	
	(method (show param1)
		(self cel: param1)
		(super show:)
	)
)

(instance captainsScript of Script
	(properties
		seconds 3
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(1
				(Print 28 2 #dispose)
				(= seconds 10)
			)
			(2
				(gIceKeyDownHandler delete: self)
				(gIceMouseDownHandler delete: self)
				(if gDialog (gDialog dispose:))
				(= seconds 10)
			)
			(3
				(if gDialog (gDialog dispose:))
				(Print 28 3)
				(= start state)
				(= seconds 10)
			)
			(4 (self init:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((== state 1) (= cycles 1))
			((super handleEvent: pEvent))
			((Said 'address[/man,captain]') (client setScript: binocularScript))
			(
				(or
					(Said 'exit,exit')
					(Said 'go<below')
					(Said 'climb<down/ladder')
				)
				(Print 28 4)
			)
		)
	)
)

(instance binocularScript of Script
	(properties)
	
	(method (dispose)
		(if gDialog (gDialog dispose:))
		(super dispose:)
	)
	
	(method (changeState newState)
		(if gDialog (gDialog dispose:))
		(switch (= state newState)
			(0
				(HandsOff)
				(Print 28 5 #dispose)
			)
			(1 (Print 28 6 #dispose))
			(2 (Print 28 7 #dispose))
			(3
				(captainP setPri: 6 setCycle: CT 7 1 self)
			)
			(4 (= cycles 3))
			(5
				(gEgo setPri: 7 setCycle: CT 4 1 self)
			)
			(6
				(captainP setCycle: End self)
			)
			(7 (gEgo setCycle: End self))
			(8
				(binocularV show: 2)
				(= seconds 10)
			)
			(9
				(binocularV hide:)
				(Print 28 8 #dispose)
			)
			(10
				(gEgo setPri: 6 setCycle: CT 4 -1 self)
			)
			(11
				(captainP setPri: 7 setCycle: CT 7 -1 self)
			)
			(12
				(gEgo setCycle: Beg self)
				(captainP setCycle: Beg self)
			)
			(13)
			(14
				(User canInput: 1)
				(Print 28 9 #dispose)
				(= seconds 15)
			)
			(15
				(User canInput: 0)
				(Print 28 10 #dispose)
			)
			(16
				(gIceGlobalSound fade:)
				(Print 28 11 #dispose)
				(= seconds 10)
			)
			(17 (gRoom newRoom: 25))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((== state 14)
				(cond 
					((== (pEvent type?) evSAID)
						(if
							(or
								(Said 'get,(look[<at])/binoculars')
								(Said 'binoculars<use')
							)
							(self setScript: lookBinocsScript self seconds: 0)
						)
					)
					(gDialog (gDialog dispose:))
				)
			)
			((proc999_5 state 0 1 2 9 15 16) (= cycles 2))
		)
	)
)

(instance lookBinocsScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(captainP setPri: 6 setCycle: CT 7 1 self)
			)
			(1 (= cycles 3))
			(2
				(gEgo setPri: 7 setCycle: CT 4 1 self)
			)
			(3
				(captainP setCycle: End self)
			)
			(4 (gEgo setCycle: End self))
			(5
				(binocularV show: 3)
				(= seconds 5)
			)
			(6
				(binocularV hide:)
				(Print 28 8 #dispose)
				(gEgo setPri: 6 setCycle: CT 4 -1 self)
			)
			(7
				(captainP setPri: 7 setCycle: CT 7 -1 self)
			)
			(8
				(gEgo setCycle: Beg self)
				(captainP setCycle: Beg self)
			)
			(9)
			(10 (self dispose:))
		)
	)
)
