;;; Sierra Script 1.0 - (do not remove this comment)
(script# 32)
(include sci.sh)
(use Main)
(use Class_255_0)
(use n316)
(use n824)
(use n954)
(use ForwardCounter)
(use Grooper)
(use Avoid)
(use Cycle)
(use Game)
(use User)
(use Feature)
(use Obj)

(public
	galleyRm 0
)

(instance galleyRm of Rm
	(properties
		picture 32
		horizon 12
		north 25
		south 34
		west 41
		vanishingX 315
		vanishingY 58
	)
	
	(method (init)
		(super init:)
		(gEgo init: setPri: -1)
		(switch gPrevRoomNum
			(25
				(gEgo
					ignoreControl: -32768
					posn: 93 21
					view: 32
					setLoop: 3
					setScript: decendStairsScript
				)
			)
			(39
				(egoChair hide:)
				(if (gEgo looper?) ((gEgo looper?) dispose:))
				(gEgo
					view: 32
					setLoop: 7
					ignoreControl: -32768
					posn: (egoChair x?) (egoChair y?)
					setCel: 16
					cycleSpeed: 2
					setPri: -1
					setScript: egoStandsScript
				)
				(oldSalt
					init:
					ignoreControl: -32768
					posn: (oldSaltChair x?) (oldSaltChair y?)
					view: 32
					cycleSpeed: 2
					setLoop: 6
					setCel: 16
					setScript: oldSaltStandScript
				)
			)
			(west (gEgo posn: 59 108))
			(south
				(gEgo posn: 109 141 heading: 45 loop: 6)
			)
			(else 
				(HandsOn)
				(gEgo posn: 116 122 view: 232)
			)
		)
		(oldSaltChair init: ignoreActors: 1)
		(egoChair init: ignoreActors: 1)
		(chef init: stopUpd: setScript: chefScript)
		(gAddToPics add: pipes skillet doit:)
		(proc824_0)
		(self setFeatures: stairsFeat setRegions: 314)
		(proc316_0 gCurRoomNum 4)
		(if (proc316_1 gCurRoomNum 4)
			(rumBottle init: setPri: 8 ignoreActors: 1)
		)
	)
	
	(method (doit)
		(if (== (gEgo onControl: 1) 16384)
			(self newRoom: 34)
		else
			(super doit:)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'stand')
				(if (== (gEgo view?) 32)
					(gEgo setScript: egoStandsScript)
				else
					(Print 32 0)
				)
			)
			((Said 'look>')
				(cond 
					((Said '[<at,around][/room]') (Print 32 1) (Print 32 2) (Print 32 3))
					((Said '/table')
						(if
							(and
								(gCast contains: rumBottle)
								(not (& (rumBottle signal?) $0008))
							)
							(Print 32 4)
						else
							(Print 32 5)
						)
					)
					((Said '/kitchen') (Print 32 6))
					((Said '/menu') (Print 32 7))
				)
			)
		)
	)
)

(instance pipes of PV
	(properties
		y 185
		x 193
		view 32
		priority 15
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/pipe]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 32 8))
				)
			)
		)
	)
)

(instance skillet of PV
	(properties
		y 45
		x 164
		view 32
		cel 1
		priority 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((proc954_1 self pEvent 'look[<at]/pan,pan'))
			((Said 'look[<at][/pan,pan]') (Print 32 9))
		)
	)
)

(instance chef of Prop
	(properties
		y 78
		x 142
		view 32
		loop 1
		priority 5
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/chef,man,cook]>')
				(cond 
					((proc954_1 self pEvent 'address,(look[<at])/*'))
					((Said 'look[<at]') (Print 32 10))
					((Said 'address') (Print 32 11))
					((Said 'ask//key') (Print 32 12))
				)
			)
		)
	)
)

(instance serveItScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(Print 32 13 #at 30 20 #time 8 #dispose)
				(chef setLoop: 5 cycleSpeed: 2 setCycle: End self)
			)
			(1
				(burger init:)
				(chef
					setLoop: 1
					setCel: 0
					cycleSpeed: 0
					setScript: chefScript
				)
			)
		)
	)
)

(instance burger of View
	(properties
		view 32
		cel 5
	)
	
	(method (init)
		(super init:)
		(self posn: (+ (chef x?) 34) (- (chef y?) 1))
	)
)

(instance chefScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0 (= seconds (Random 5 20)))
			(1
				(client
					setLoop: 4
					setCycle: ForwardCounter (Random 5 8) self
				)
			)
			(2
				(client setLoop: 1 setCycle: End self)
			)
			(3
				(client stopUpd:)
				(self init:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'get,order/food,sandwich,burger')
					(and (not register) (Said 'eat'))
				)
				(cond 
					((!= (gEgo view?) 232) (PrintNotNow))
					(register (Print 32 14))
					(else (client setScript: serveItScript) (= register 1))
				)
			)
			((Said 'eat[/food,sandwich,burger]')
				(cond 
					((!= (gEgo view?) 232) (PrintNotNow))
					((gCast contains: burger) (Print 32 15) (burger dispose:))
					(else (Print 32 16))
				)
			)
		)
	)
)

(instance egoStandsScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gEgo
					heading: 90
					yStep: 2
					setMotion: MoveTo (egoChair x?) (egoChair y?)
					setCycle: Beg self
				)
			)
			(1
				(egoChair show:)
				(gEgo
					posn: (- (egoChair x?) 23) (+ (egoChair y?) 1)
					cycleSpeed: 0
					heading: 270
					view: 232
					setLoop: -1
					setLoop: Grooper
					setCycle: Walk
					setMotion: MoveTo 229 106 self
				)
			)
			(2
				(HandsOn)
				(gEgo heading: 270)
				((gEgo looper?) doit: gEgo (gEgo heading?) self)
			)
			(3
				(gEgo observeControl: -32768)
				(self dispose:)
			)
		)
	)
)

(instance rumBottle of View
	(properties
		y 98
		x 239
		view 32
		cel 2
		priority 9
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((& signal $0008))
			((Said '[/bottle[<rum]]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 32 17))
					((Said 'get,drink')
						(cond 
							((>= (gEgo distanceTo: self) 40) (PrintNotCloseEnough))
							((gCast contains: oldSalt) (pEvent claimed: 0))
							(else (oldSalt init: setScript: oldSaltScript))
						)
					)
				)
			)
		)
	)
)

(instance oldSalt of Act
	(properties
		y 112
		x 46
		view 132
	)
	
	(method (init)
		(super init:)
		(self ignoreControl: -32768 setCycle: Walk)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((proc954_1 self pEvent 'look[<at]/man[<old]'))
			((Said 'look[<at][/man[<old]]') (Print 32 18))
			((Said 'ask[/name]') (Print 32 19) (Print 32 20) (Print 32 21))
		)
	)
)

(instance oldSaltScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(Print 32 22 #at 30 20 #dispose)
				(oldSalt
					ignoreActors: 1
					setMotion: MoveTo (- (oldSaltChair x?) 13) (oldSaltChair y?) self
				)
				(if (proc999_4 210 115 257 124 gEgo)
					(gEgo setMotion: MoveTo 209 120)
				)
			)
			(1
				(if (and (== (gEgo x?) 209) (== (gEgo y?) 120))
					(gEgo loop: 0)
				)
				(if gDialog (gDialog dispose:))
				(oldSaltChair hide:)
				(oldSalt
					x: (+ (oldSalt x?) 13)
					view: 32
					cycleSpeed: 2
					setLoop: 6
					setCel: 0
					setCycle: End self
				)
			)
			(2
				(Print 32 23 #at 30 20)
				(= cycles 2)
			)
			(3
				(Print 32 24 #at 30 20)
				(User canInput: 1)
				(= seconds 10)
			)
			(4
				(Print 32 25 #at 30 20)
				((gInv at: 4) moveTo: -1)
				(rumBottle hide:)
				(client setScript: oldSaltStandScript)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((!= state 3))
			((or (Said 'affirmative') (Said 'play[/game]')) (gEgo setScript: diceGameScript) (self dispose:))
			((Said 'n') (self cue:))
		)
	)
)

(instance oldSaltStandScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(oldSalt ignoreActors: 1 heading: 90 setCycle: Beg self)
			)
			(1
				(oldSaltChair show:)
				(oldSalt
					view: 132
					setCycle: Walk
					setLoop: -1
					setLoop: Grooper
					heading: 270
				)
				((oldSalt looper?) doit: oldSalt (oldSalt heading?))
				(= cycles 10)
			)
			(2
				(oldSalt
					cycleSpeed: 0
					setPri: -1
					setLoop: -1
					setCycle: Walk
					setMotion: MoveTo 46 112 self
				)
			)
			(3 (HandsOn) (self dispose:))
		)
	)
)

(instance oldSaltChair of View
	(properties
		y 121
		x 235
		view 32
		cel 3
	)
)

(instance diceGameScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (!= (gEgo view?) 32)
					(self setScript: egoSitScript self)
				else
					(= cycles 1)
				)
			)
			(1 (gRoom newRoom: 39))
		)
	)
)

(instance egoSitScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0 temp1)
		(switch (= state newState)
			(0
				(if (== (gEgo onControl: 1) 8192)
					(gEgo setMotion: MoveTo 179 120 self)
				else
					(= cycles 1)
				)
			)
			(1
				(HandsOff)
				(if
					(or
						(= temp0 (< (gEgo x?) (- (egoChair x?) 32)))
						(= temp1 (< (gEgo y?) (- (egoChair y?) 8)))
					)
					(gEgo
						setAvoider: Avoid
						observeControl: 8192
						setMotion: MoveTo (- (egoChair x?) 32) (- (egoChair y?) 8) self
					)
				else
					(= cycles 1)
				)
			)
			(2
				(gEgo
					ignoreControl: -24576
					setAvoider: 0
					setMotion: MoveTo (- (egoChair x?) 23) (+ (egoChair y?) 1) self
				)
			)
			(3
				(egoChair hide:)
				(if (gEgo looper?) ((gEgo looper?) dispose:))
				(gEgo
					view: 32
					setLoop: 7
					posn: (egoChair x?) (egoChair y?)
					setCel: 0
					cycleSpeed: 1
					yStep: 1
					setCycle: CT 7 1 self
				)
			)
			(4
				(gEgo
					setMotion: MoveTo (egoChair x?) (+ (egoChair y?) 4)
					setCycle: End self
				)
			)
			(5
				(HandsOn)
				(User canControl: 0)
				(self dispose:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sit') (Print 32 0))
		)
	)
)

(instance egoChair of View
	(properties
		y 107
		x 256
		view 32
		cel 4
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sit')
				(if (== (gEgo view?) 32)
					(Print 32 0)
				else
					(gEgo setScript: egoSitScript)
				)
			)
		)
	)
)

(instance stairsFeat of Feature
	(properties
		y 126
		x 66
		heading 180
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/stair,ladder]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 32 26))
					((proc954_0 self pEvent 62 130 'climb' 32 27))
					((Said 'climb') (gEgo setScript: climbStairsScript))
				)
			)
		)
	)
)

(instance climbStairsScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo illegalBits: 0 setMotion: MoveTo 62 126 self)
			)
			(1
				(gEgo heading: 0)
				((gEgo looper?) doit: gEgo)
				(= cycles 4)
			)
			(2
				(if (gEgo looper?) ((gEgo looper?) dispose:))
				(gEgo
					view: 32
					setLoop: 2
					setPri: 9
					cycleSpeed: 1
					illegalBits: 0
					setCel: 0
				)
				(= cycles 2)
			)
			(3
				(= start state)
				(gEgo posn: (+ (gEgo x?) 2) (- (gEgo y?) 7) setCel: 1)
				(= cycles 2)
			)
			(4 (gEgo setCycle: CT 3 1 self))
			(5
				(gEgo posn: (+ (gEgo x?) 2) (- (gEgo y?) 7) setCel: 4)
				(= cycles 2)
			)
			(6 (gEgo setCycle: CT 0 1 self))
			(7 (self init:))
		)
	)
)

(instance decendStairsScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (gEgo looper?) ((gEgo looper?) dispose:))
				(gEgo
					view: 32
					setLoop: 3
					setPri: 9
					cycleSpeed: 1
					illegalBits: 0
					setCel: 0
				)
				(= cycles 2)
			)
			(1
				(= start state)
				(gEgo
					posn: (- (gEgo x?) 2) (- (gEgo y?) -7)
					setCel: 1
				)
				(= cycles 2)
			)
			(2 (gEgo setCycle: CT 3 1 self))
			(3
				(gEgo
					posn: (- (gEgo x?) 2) (- (gEgo y?) -7)
					setCel: 4
				)
				(= cycles 2)
			)
			(4 (gEgo setCycle: CT 0 1 self))
			(5
				(if (< (gEgo y?) 125)
					(self init:)
				else
					(gEgo
						view: 232
						heading: 180
						loop: 2
						setCycle: Walk
						setLoop: -1
						setLoop: Grooper
						cycleSpeed: 0
						setPri: -1
						observeControl: -32768
					)
					(HandsOn)
				)
			)
		)
	)
)
