;;; Sierra Script 1.0 - (do not remove this comment)
(script# 22)
(include sci.sh)
(use Main)
(use Class_255_0)
(use n821)
(use n958)
(use n982)
(use Cycle)
(use Game)
(use User)
(use Feature)
(use Obj)

(public
	honoluluAirportRm 0
)

(instance honoluluAirportRm of Rm
	(properties
		picture 22
	)
	
	(method (init)
		(super init:)
		(self setRegions: 302)
		(proc958_0 128 22 17)
		(gIceGlobalSound
			number: 84
			owner: gGame
			priority: 1
			loop: -1
			play:
		)
		(gEgo init: posn: 190 169 setScript: walkToDriverScript)
		(plane init:)
		(slidingDoor init:)
		(driver init:)
		(doorProp init:)
		(gAddToPics add: alohaSignPic limoPic doit:)
	)
	
	(method (dispose)
		(gIceGlobalSound fade:)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room,scene]') (Print 22 0))
			((Said 'look/airport') (Print 22 1))
			((Said 'look/car') (Print 22 2))
			((Said 'open/door') (Print 22 3))
		)
	)
)

(instance walkToDriverScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					setMotion: MoveTo (+ (driver x?) 30) (+ (driver y?) 2) self
				)
			)
			(1
				(User canInput: 1)
				(self dispose:)
			)
		)
	)
)

(instance driver of Act
	(properties
		y 164
		x 60
		view 22
		loop 4
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/man,driver]>')
				(cond 
					((Said 'look') (Print 22 4))
					((Said 'salute') (Print 22 5))
					((Said 'address') (Print 22 6) (self setScript: driverResponseScript))
				)
			)
			((Said 'show/order') (Print 22 6) (self setScript: driverResponseScript))
		)
	)
)

(instance driverResponseScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 0)
			(1
				(gRoom setScript: newRoomScript)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'affirmative')
				(if (== state 0)
					(self setScript: showIdScript self)
				else
					(Print 22 7)
				)
			)
			((Said 'show/id,order') (Print 22 8))
			((Said 'n') (gRoom setScript: endOfGameScript 0 1))
		)
	)
)

(instance showIdScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (Print 22 9))
			(1 (self dispose:))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((or (Said 'show/order') (Said 'affirmative'))
				(if (gEgo has: 0)
					(Print 22 10)
					(self cue:)
				else
					(switch (Random 0 1)
						(0 (Print 22 11))
						(1 (Print 22 12))
					)
					(gRoom setScript: endOfGameScript 0 1)
				)
			)
		)
	)
)

(instance endOfGameScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if (== register 0)
					(proc821_0 918 0 0 22 13)
				else
					(proc821_0 918 0 0 22 14)
				)
			)
		)
	)
)

(instance newRoomScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (driver setCycle: End self))
			(1
				(driver
					loop: 5
					setPri: (- (doorProp priority?) 1)
					setCycle: End self
				)
				(doorProp show: setCycle: End self)
			)
			(2 (= seconds 2))
			(3
				(gRoom drawPic: 101 setScript: messageLeavePearlScript)
			)
		)
	)
)

(instance messageLeavePearlScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gCast eachElementDo: #dispose)
				(Print 22 15)
				(Print 22 16)
				(Print 22 17)
				(gEgo put: 6 3)
				(HandsOn)
				(gRoom newRoom: 23)
			)
		)
	)
)

(instance slidingDoor of Prop
	(properties
		y 171
		x 155
		view 22
		loop 1
	)
	
	(method (init)
		(super init:)
		(self setPri: 14 ignoreActors: stopUpd:)
	)
	
	(method (doit &tmp temp0)
		(super doit:)
		(cond 
			(
				(and
					(< (= temp0 (gEgo distanceTo: self)) 45)
					(not cel)
				)
				(self setCycle: End self)
			)
			((and (>= temp0 45) cel) (self setCycle: Beg self))
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance plane of Act
	(properties
		view 17
		loop 5
	)
	
	(method (init)
		(super init:)
		(self
			setLoop: loop
			ignoreControl: -32768
			setScript: planeScript
			stopUpd:
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((proc982_0 self))
			((Said 'look[<at][/airplane,airplane,jet]') (Print 22 18))
		)
	)
)

(instance planeScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds (Random 10 20)))
			(1
				(plane posn: -5 7 setMotion: MoveTo 340 7 self)
			)
			(2
				(client stopUpd:)
				(= seconds (Random 20 40))
			)
			(3 (self init: client))
		)
	)
)

(instance alohaSignPic of PV
	(properties
		y 189
		x 289
		view 22
	)
)

(instance limoPic of PV
	(properties
		y 189
		x 34
		view 22
		loop 2
	)
)

(instance doorProp of Prop
	(properties
		y 157
		x 42
		view 22
		loop 3
	)
	
	(method (init)
		(super init:)
		(self ignoreActors: stopUpd: hide:)
	)
	
	(method (cue)
		(self hide: stopUpd:)
	)
)
