;;; Sierra Script 1.0 - (do not remove this comment)
(script# 9)
(include sci.sh)
(use Main)
(use Class_255_0)
(use tahiti)
(use n954)
(use n958)
(use RFeature)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	hotelEntrance 0
)

(instance hotelEntrance of Rm
	(properties
		picture 9
		horizon 128
		north 10
		east 12
		south 2
		west 3
	)
	
	(method (init)
		(super init:)
		(gAddToPics add: newsStand eachElementDo: #init doit:)
		(Load rsSOUND 42)
		(Load rsSOUND 36)
		(proc958_0 128 9 9 206 200 109 209)
		(self
			setRegions: 300 301
			setFeatures:
				hut
				newsStand
				flowerFeat
				westwindow
				((Clone westwindow)
					x: 145
					nsTop: 84
					nsBottom: 116
					nsLeft: 140
					nsRight: 151
					heading: 180
					name: {middleLeftWindow}
					yourself:
				)
				((Clone westwindow)
					x: 180
					nsTop: 84
					nsBottom: 119
					nsLeft: 170
					nsRight: 189
					heading: 180
					name: {middleRightWindow}
					yourself:
				)
				((Clone westwindow)
					x: 235
					nsTop: 100
					nsBottom: 129
					nsLeft: 219
					nsRight: 252
					heading: 180
					name: {eastLeftWindow}
					yourself:
				)
				((Clone westwindow)
					x: 282
					nsTop: 97
					nsBottom: 129
					nsLeft: 262
					nsRight: 302
					heading: 180
					name: {eastRightWindow}
					yourself:
				)
		)
		(gEgo init: observeControl: 16384)
		(switch gPrevRoomNum
			(north (gEgo posn: 106 135))
			(else  (gEgo posn: 106 188))
		)
		(egoReflection init:)
		(lobbyDoor init:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room]') (Print 9 0))
		)
	)
	
	(method (newRoom)
		(super newRoom: &rest)
		(gEgo ignoreControl: 16384)
	)
)

(instance egoReflection of Prop
	(properties
		view 9
	)
	
	(method (init)
		(self ignoreActors: setPri: 8)
		(super init:)
	)
	
	(method (doit &tmp gEgoX gEgoLoop)
		(super doit:)
		(if (> 137 (gEgo y?)) (self show:) else (self hide:))
		(= gEgoX (gEgo x?))
		(= gEgoLoop (gEgo loop?))
		(self
			setLoop: (if (> gEgoLoop 3) (- gEgoLoop 4) else gEgoLoop)
			setCel: (gEgo cel?)
			posn:
				(if (< gEgoX 160) (+ gEgoX 3) else (- gEgoX 3))
				(- (gEgo y?) 2)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at]/glass,reflection') (Print 9 1 #time 10))
		)
	)
)

(instance lobbyDoor of Prop
	(properties
		y 132
		x 133
		heading 180
		view 209
		loop 4
	)
	
	(method (init)
		(super init:)
		(switch gPrevRoomNum
			((gRoom north?)
				(self
					setCel: (self lastCel:)
					ignoreActors:
					setCycle: Beg self
				)
				(theSound number: (DecideSound 42) loop: 1 play:)
			)
			(else 
				(self ignoreActors: stopUpd:)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 9 2))
					((Said 'close/*') (Print 9 3))
					((Said 'knock/*') (Print 9 4))
					(
						(proc954_0
							self
							pEvent
							(- (lobbyDoor x?) 14)
							(+ (lobbyDoor y?) 2)
							0
							9
							5
						)
					)
					((Said 'open/*')
						(if (!= (gEgo view?) 206)
							(Print 9 6)
						else
							(self setScript: openDoorScript self)
						)
					)
				)
			)
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance openDoorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo loop: 3 heading: 0)
				(lobbyDoor setCycle: End self)
				(theSound number: (DecideSound 36) loop: 1 play:)
			)
			(1
				(gEgo
					ignoreControl: 16384
					setMotion: MoveTo (gEgo x?) (- (gEgo y?) 8)
					setAvoider: 0
				)
				(client setScript: 0)
			)
		)
	)
)

(instance newsStand of RPicView
	(properties
		y 132
		x 151
		heading 180
		view 109
		priority 9
		signal $4000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look/stand<magazine') (Print 9 7))
			(
			(Said '[/stand<newspaper,news,times,newspaper]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at,in]')
						(if (> (gEgo distanceTo: self) 35)
							(Print 9 8)
						else
							(Print 9 9)
						)
					)
				)
			)
			((Said '[/newspaper,news,times,newspaper]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 9 10))
					((proc954_0 self pEvent self 25 0 9 5))
					((Said 'get,get') (Print 9 11))
					((Said 'buy')
						(if (gEgo has: 4)
							(Print 9 12)
							(gEgo setScript: readPaperScript)
						else
							(Print 9 13)
						)
					)
				)
			)
			((Said '[/money,change,cent,coin]>')
				(cond 
					((proc954_1 self pEvent 'deposit,insert'))
					(
					(proc954_0 self pEvent self 25 'deposit,insert' 9 5))
					((Said 'deposit,insert')
						(if (gEgo has: 4)
							(Print 9 12)
							(gEgo setScript: readPaperScript)
						else
							(Print 9 13)
						)
					)
				)
			)
		)
	)
)

(instance readPaperScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(tahiti flags: (| (tahiti flags?) $0008))
				(gEgo
					put: 4 gCurRoomNum
					setLoop: (if (== (gEgo view?) 206) 1 else 2)
					view: 109
					cycleSpeed: 1
					setCel: (gEgo lastCel:)
					setCycle: Beg self
				)
			)
			(1
				(Print 9 14 #at 65 120)
				(Print 9 15 #at 65 120)
				(gEgo setCycle: End self)
			)
			(2 (gEgo setCycle: Beg self))
			(3
				(Print 9 16 #at 65 120)
				(Print 9 17 #at 65 120)
				(Print 9 18 #at 65 120)
				(Print 9 19 #at 30 120 #width 260)
				(gEgo setCycle: End self)
			)
			(4
				(gEgo
					view: (if (== (gEgo loop?) 1) 206 else 200)
					cycleSpeed: 0
					setLoop: -1
					loop: 3
					setCycle: Walk
				)
				(= cycles 1)
			)
			(5
				(Print 9 20 #at 65 120)
				(gGame changeScore: 2)
				(gEgo setScript: 0)
				(HandsOn)
			)
		)
	)
)

(instance flowerFeat of RFeature
	(properties
		y 136
		x 26
		z 30
		nsTop 107
		nsBottom 123
		nsRight 68
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/planter,flower,box]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]'))
					((Said 'look[<at]') (Print 9 21))
				)
			)
		)
	)
)

(instance westwindow of RFeature
	(properties
		y 106
		x 26
		z 10
		heading 180
		nsTop 84
		nsBottom 105
		nsRight 68
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/shutter]>')
				(cond 
					((proc954_1 self pEvent 'look[<at,in]'))
					((Said 'look[<at,in]')
						(if (> (gEgo distanceTo: self) 20)
							(Print 9 22)
						else
							(Print 9 23)
						)
					)
				)
			)
		)
	)
)

(instance hut of RFeature
	(properties
		y 38
		x 159
		heading 180
		nsBottom 77
		nsRight 319
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/building]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]'))
					((Said 'look[<at]') (Print 9 2))
				)
			)
		)
	)
)

(instance theSound of Sound
	(properties
		priority 2
	)
)
