;;; Sierra Script 1.0 - (do not remove this comment)
(script# 6)
(include sci.sh)
(use Main)
(use Class_255_0)
(use tahiti)
(use n316)
(use n824)
(use n954)
(use n958)
(use RFeature)
(use n982)
(use Avoid)
(use Sound)
(use Cycle)
(use Game)
(use User)
(use Feature)
(use Obj)

(public
	inEgosHut 0
)

(local
	[local0 20]
)
(procedure (localproc_000c)
	(return
		(if
			(and
				(closetProp cel?)
				(not (proc982_1 closetView gEgo 270 50))
			)
			(closetView show:)
			(return 1)
		else
			(closetView hide:)
			(return 0)
		)
	)
)

(instance inEgosHut of Rm
	(properties
		picture 6
		north 8
		south 5
		vanishingX 170
		vanishingY -20
	)
	
	(method (init)
		(super init:)
		(gAddToPics
			add: fishPic floorPic
			eachElementDo: #init
			doit:
		)
		(proc958_0 128 200 206 106 6)
		(Load rsSOUND 42)
		(Load rsSOUND 36)
		(drawerView init:)
		(closetView init:)
		(phone init:)
		(drawerProp init:)
		(closetProp init:)
		(gEgo init:)
		(switch gPrevRoomNum
			(8
				(gEgo setScript: walkUpLadderScript)
			)
			(else 
				(if (> (gEgo y?) 170)
					(gEgo posn: 77 68 loop: 0)
				else
					(gEgo posn: (hutDoor x?) (- (hutDoor y?) 9) loop: 3)
				)
			)
		)
		(self
			setRegions: 300
			setFeatures:
				hutDoor
				fishPic
				floorPic
				flowersOnTable
				closetDoorFeature
				bedFeature
				backCouchF
				leftCouch
				((Clone bedFeature)
					x: 36
					y: 128
					nsTop: 114
					nsBottom: 142
					nsLeft: 28
					nsRight: 44
					yourself:
				)
				((Clone leftCouch)
					x: 215
					y: 98
					nsLeft: 219
					nsTop: 82
					nsRight: 244
					nsBottom: 114
					heading: 270
					name: {rightCouch} species
				)
				lampFeature
				windowFeature
				rugFeature
				floorFeature
				((Clone floorFeature) x: 105 y: 209 yourself:)
				((Clone windowFeature)
					x: 220
					y: 40
					nsTop: 15
					nsBottom: 68
					nsLeft: 180
					nsRight: 260
					yourself:
				)
				oceanFeat
				((Clone rugFeature)
					x: 160
					y: 95
					nsTop: 80
					nsBottom: 110
					nsLeft: 136
					nsRight: 186
					yourself:
				)
		)
		(proc824_0)
		(proc316_0 gCurRoomNum 3 2 4)
	)
	
	(method (doit)
		(super doit:)
		(if (& (gEgo onControl: 1) $4020) (self newRoom: 5))
	)
	
	(method (dispose)
		(HandsOn)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look>') (if (Said '[<around][/room][/building]') (Print 6 0)))
			((Said 'rest') (Print 6 1))
			((Said 'jump,swim,dive,enter,(go<in)[/water]')
				(cond 
					((== (gEgo view?) 206) (Print 6 2))
					((== (gEgo onControl: 1) 16) (gEgo setScript: fallInWaterScript))
					(else (Print 6 3))
				)
			)
			((Said 'read/book')
				(if (gEgo has: 3)
					(Print 6 4 #icon 300 1 0)
				else
					(pEvent claimed: 0)
				)
			)
			((Said 'turn<on,off/light') (PrintDontNeed))
		)
	)
	
	(method (cue)
		(super cue:)
		(self newRoom: 8)
	)
)

(instance fallInWaterScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo setAvoider: Avoid setMotion: MoveTo 158 67 self)
			)
			(1
				(gEgo heading: 0)
				((gEgo looper?) doit: gEgo 0)
				(= cycles 5)
			)
			(2
				((gEgo looper?) dispose:)
				(gEgo
					setPri: 0
					yStep: 10
					illegalBits: 0
					looper: 0
					setLoop:
					setMotion: MoveTo (gEgo x?) 107 self
				)
			)
			(3
				(HandsOn)
				(gEgo
					yStep: 2
					setPri: -1
					setLoop: -1
					observeControl: -32768
				)
				(gRoom newRoom: 8)
			)
		)
	)
)

(instance walkUpLadderScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo
					view: 200
					setLoop: 2
					posn: 158 107
					setPri: 0
					moveSpeed: 1
					setMotion: MoveTo 158 67 self
				)
			)
			(1
				(HandsOn)
				(gEgo heading: 180 setPri: -1 moveSpeed: 0 setLoop: -1)
			)
		)
	)
)

(instance hutDoor of Feature
	(properties
		y 175
		x 122
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door[<building]][/building]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 5))
					((Said 'knock') (Print 6 6))
					((proc954_0 self pEvent x (- y 5) 0 6 7))
					((Said 'open') (gRoom setScript: egoOpenDoorScript))
				)
			)
		)
	)
)

(instance phone of Prop
	(properties
		y 155
		x 29
		z 7
		view 106
		loop 1
		priority 11
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/call,braxton]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 8))
					(
						(or
							(Said '(get[<!*]),call,dial,(pick<up)')
							(Said 'call<use')
							(Said 'make/call<call')
						)
						(cond 
							((== (gEgo onControl: 1) 16) (Print 6 9))
							((User controls?)
								(HandsOff)
								(gEgo
									setAvoider: Avoid
									setMotion: MoveTo (+ 25 x) (+ 7 y) self
								)
							)
							(else (Print 6 7))
						)
					)
				)
			)
		)
	)
	
	(method (cue)
		(gEgo setScript: phoneScript)
	)
)

(instance phoneScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(client
					view: 106
					loop: (if (== (gEgo view?) 200) 0 else 4)
					setCycle: End self
				)
				(phone cel: 1 forceUpd:)
			)
			(1
				(Print 6 10 #edit @local0 18)
				(= seconds 3)
			)
			(2
				(cond 
					((not (StrCmp @local0 {})) (self cue:))
					((not (StrCmp @local0 {1-202-555-2729}))
						(if
							(and
								(& (tahiti flags?) $0100)
								(not (& (tahiti flags?) $0080))
							)
							(Print 6 11 #time 10)
							(Print 6 12)
							(User canInput: 1)
							(= register 0)
							(= seconds 10)
						else
							(Print 6 13 #time 10)
							(gEgo setScript: putDownPhoneScript)
						)
					)
					((not (StrCmp @local0 {555-6969}))
						(if
							(and
								(& (tahiti flags?) $0100)
								(& (tahiti flags?) $0080)
								(not (& (tahiti flags?) $0200))
							)
							(Print 6 14)
							(User canInput: 1)
							(= register 1)
							(= seconds 10)
						else
							(Print 6 15)
							(gEgo setScript: putDownPhoneScript)
						)
					)
					(else
						(Print 6 16 #time 10)
						(gEgo setScript: putDownPhoneScript)
					)
				)
			)
			(3
				(Print 6 17)
				(gEgo setScript: putDownPhoneScript)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(register
				(if
					(or
						(Said 'address[/man,clerk]')
						(Said '//boat,transport<for,about')
						(Said '/hello')
						(Said
							'/lieutenant,commander,john,westland,(westland<john)'
						)
					)
					(Print 6 18)
					(Print 6 19)
					(tahiti setScript: (ScriptID 300 1))
					(tahiti flags: (| (tahiti flags?) $0200))
					(gGame changeScore: 2)
				else
					(Print 6 20)
					(pEvent claimed: 1)
				)
				(Print 6 17)
				(gEgo setScript: putDownPhoneScript)
			)
			(else
				(if
					(or
						(Said 'address[/man,general,braxton]')
						(Said '//message<for,about')
						(Said '/hello')
						(Said
							'/lieutenant,commander,john,westland,(westland<john)'
						)
					)
					(Print 6 21)
					(Print 6 22)
					(if ((tahiti script?) state?)
						(Print 6 23)
						(Print 6 24)
					else
						(Print 6 25)
						(gGame changeScore: 2)
					)
					(Print 6 26)
					(Print 6 27)
					(Print 6 28)
					(tahiti flags: (| (tahiti flags?) $0080))
				else
					(Print 6 20)
					(pEvent claimed: 1)
				)
				(Print 6 17)
				(gEgo setScript: putDownPhoneScript)
			)
		)
	)
)

(instance putDownPhoneScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gEgo setCycle: Beg self)
				(phone cel: 0 forceUpd:)
			)
			(1
				(gEgo
					view: (if (== (gEgo loop?) 0) 200 else 206)
					loop: 1
					setLoop: -1
					setCycle: Walk
					setScript: 0
				)
				(HandsOn)
			)
		)
	)
)

(instance drawerProp of Prop
	(properties
		y 168
		x 33
		z 7
		view 6
	)
	
	(method (init)
		(super init:)
		(if (& (tahiti flags?) $0020) (= cel (self lastCel:)))
		(self setPri: 12 stopUpd: ignoreActors: 1)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said '[/dresser,drawer,dresser,lamp,light,flower]>')
				(cond 
					((and (== (gEgo onControl: 1) 16) (Said '/*')) (Print 6 9))
					((proc954_1 self pEvent 'look[<at,in,on]/*'))
					(
						(or
							(Said 'look[<on]/dresser,drawer,dresser')
							(Said 'look/lamp,light,flower')
						)
						(Print 6 29)
					)
					((Said 'look[<at,in]')
						(if (not cel)
							(Print 6 30)
						else
							(drawerView show:)
							(cond 
								(
									(and
										(proc316_1 gCurRoomNum 2)
										(proc316_1 gCurRoomNum 4)
									)
									(Print 6 31)
								)
								((proc316_1 gCurRoomNum 2) (Print 6 32))
								((proc316_1 gCurRoomNum 4) (Print 6 33))
								(else (Print 6 34))
							)
						)
					)
					(
					(proc954_0 self pEvent self 20 'open,close,examine' 6 7))
					((Said 'open')
						(drawerView show:)
						(if cel
							(Print 6 35)
						else
							(tahiti flags: (| (tahiti flags?) $0020))
							(self setCycle: End self)
						)
					)
					((Said 'close')
						(if (not cel)
							(Print 6 36)
						else
							(PrintOK)
							(drawerView hide:)
							(tahiti flags: (& (tahiti flags?) $ffdf))
							(self setCycle: Beg self)
						)
					)
					((Said 'examine') (Print 6 37))
				)
			)
			(
			(Said 'adjust,return,drop[/id,card,change,money]>')
				(cond 
					((proc954_1 self pEvent 'adjust,return,drop/*'))
					((proc954_0 self pEvent (+ 20 x) y 0 6 7))
					((not cel) (Print 6 38) (pEvent claimed: 1) (return))
					((Said '/change,money')
						(if (gEgo has: 4)
							(Change show:)
							(Print 6 39)
							(gEgo put: 4 gCurRoomNum)
						else
							(PrintDontHave)
						)
					)
					((gEgo has: 2) (Wallet show:) (Print 6 40) (gEgo put: 2 gCurRoomNum))
					(else (PrintDontHave))
				)
			)
		)
	)
	
	(method (cue)
		(if cel (drawerView show:))
		(self stopUpd:)
	)
)

(instance drawerView of View
	(properties
		y 155
		x 35
		z 110
		view 6
		loop 1
	)
	
	(method (init)
		(super init:)
		(Change init:)
		(Wallet init:)
		(self setPri: 14 hide:)
	)
	
	(method (doit)
		(super doit:)
		(if (proc982_1 self gEgo 180 50) (self hide:))
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((proc255_5 self pEvent)
				(if
					(not
						(if (proc316_1 gCurRoomNum 4)
						else
							(proc316_1 gCurRoomNum 2)
						)
					)
					(Print 6 41)
					(pEvent claimed: 1)
				)
			)
		)
	)
	
	(method (hide)
		(super hide:)
		(= signal (| signal $0100))
		(Wallet hide:)
		(Change hide:)
	)
	
	(method (show)
		(super show:)
		(= signal (& signal $feff))
		(if (proc316_1 gCurRoomNum 4) (Change show:))
		(if (proc316_1 gCurRoomNum 2) (Wallet show:))
	)
)

(instance closetProp of Prop
	(properties
		y 161
		x 293
		view 6
		loop 7
		priority 11
		signal $4011
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/closet,(door<closet)]>')
				(cond 
					((proc954_1 self pEvent 'look[<at,in]/*'))
					((Said 'look[<at,in]') (if (localproc_000c) (Print 6 42) else (Print 6 43)))
					((proc954_0 self pEvent self 10 0 6 7))
					((Said 'open')
						(if (localproc_000c)
							(Print 6 35)
						else
							(self setCycle: End self)
						)
					)
					((Said 'close')
						(if cel
							(self setCycle: Beg self)
							(closetView hide:)
						else
							(Print 6 36)
						)
					)
				)
			)
			((Said 'look[<at]/coat,coat,coat,clothes,pants')
				(if (not (localproc_000c))
					(Print 6 44)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
	
	(method (cue)
		(localproc_000c)
		(self stopUpd:)
	)
)

(instance closetView of View
	(properties
		y 155
		x 313
		z 80
		view 6
		loop 6
		cel 1
		priority 15
		signal $4010
	)
	
	(method (init)
		(super init:)
		(self hide:)
	)
	
	(method (doit)
		(super doit:)
		(localproc_000c)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((& signal $0008))
			(
				(or
					(Said '(get[<!*]),wear,(adjust<on)/coat,clothes,uniform')
					(Said 'change/clothes')
					(Said 'dress')
				)
				(Print 6 45)
			)
			((Said 'pack/bag,coat,clothes,uniform,briefcase') (PrintDontNeed))
			((Said 'examine,look[<at,in]>')
				(cond 
					((Said '/coat,coat,coat,clothes') (Print 6 46))
					((Said '/pocket[/coat,coat]')
						(if (proc316_1 gCurRoomNum 3)
							(Print 6 47)
						else
							(Print 6 48)
						)
					)
					((Said '[/closet]') (Print 6 49))
				)
			)
			((Said '(get[<!*])/book[<call,black,address]')
				(if (proc316_1 gCurRoomNum 3)
					(PrintOK)
					(gEgo get: 3)
				else
					(PrintAlreadyTookIt)
				)
			)
			(
			(Said 'return,drop,adjust/book[<call,black,address]')
				(if (gEgo has: 3)
					(PrintOK)
					(gEgo put: 3 gCurRoomNum)
				else
					(PrintDontHave)
				)
			)
		)
	)
	
	(method (hide)
		(super hide:)
		(= signal (| signal $0100))
	)
	
	(method (show)
		(super show:)
		(= signal (& signal $feff))
	)
)

(instance Wallet of Prop
	(properties
		y 145
		x 25
		z 120
		view 6
		loop 1
		cel 1
	)
	
	(method (init)
		(super init:)
		(gIceMouseDownHandler addToFront: self)
		(self setPri: 15 posn: 25 145)
	)
	
	(method (dispose)
		(gIceMouseDownHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/id,card]')
				(if
					(and
						(proc316_1 gCurRoomNum 2)
						(& (tahiti flags?) $0020)
					)
					(Print 6 50)
				else
					(pEvent claimed: 0)
				)
			)
			(
			(or (Said '(get[<!*])/id,card') (proc255_5 self pEvent))
				(cond 
					((not (& (tahiti flags?) $0020)) (pEvent claimed: 0))
					((proc316_1 gEgo 2)
						(if (Said '(get[<!*])/id,card')
							(Print 6 51)
						else
							(Print 6 52)
						)
					)
					((not (User canControl:)) (Print 6 53))
					((> (gEgo distanceTo: self) 40) (gEgo setAvoider: Avoid setMotion: MoveTo 56 165 self))
					((proc316_1 gCurRoomNum 2) (self cue:))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(PrintOK)
		(gEgo get: 2)
		(self hide:)
	)
)

(instance Change of Prop
	(properties
		y 145
		x 42
		z 120
		view 6
		loop 1
		cel 2
	)
	
	(method (init)
		(super init:)
		(gIceMouseDownHandler addToFront: self)
		(self setPri: 15 posn: 42 145)
	)
	
	(method (dispose)
		(gIceMouseDownHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/change,coin,money]')
				(if
					(and
						(proc316_1 gCurRoomNum 4)
						(& (tahiti flags?) $0020)
					)
					(Print 6 54)
				else
					(pEvent claimed: 0)
				)
			)
			(
				(or
					(Said 'get/change,coin,money')
					(proc255_5 self pEvent)
				)
				(cond 
					((not (& (tahiti flags?) $0020)) (pEvent claimed: 0))
					((proc316_1 gEgo 4)
						(if (Said 'get/change,coin,money')
							(Print 6 51)
						else
							(Print 6 52)
						)
					)
					((not (User canControl:)) (Print 6 53))
					((> (gEgo distanceTo: self) 40) (gEgo setAvoider: Avoid setMotion: MoveTo 56 165 self))
					((proc316_1 gCurRoomNum 4) (self cue:))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(self hide: stopUpd:)
		(Print 6 55 #time 10)
		(gEgo get: 4)
	)
)

(instance fishPic of RPicView
	(properties
		y 120
		x 34
		view 6
		loop 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/painting,wall]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 56))
					((Said 'move/*') (PrintDontNeed))
				)
			)
		)
	)
)

(instance floorPic of RPicView
	(properties
		y 109
		x 105
		view 6
		loop 4
		cel 1
		priority 6
		signal $4000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/floor,floor]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at,down,through]') (if (not (Random 0 5)) (Print 6 57) else (Print 6 58)))
				)
			)
		)
	)
)

(instance flowersOnTable of RFeature
	(properties
		y 62
		x 119
		z 10
		heading 180
		nsTop 50
		nsLeft 108
		nsBottom 75
		nsRight 131
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/table,flower]>')
				(cond 
					((and (< (gEgo y?) y) (Said '/!*>')))
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 59))
					((proc954_0 self pEvent x (+ 25 y) 0 6 7))
					((Said 'smell') (Print 6 60))
				)
			)
		)
	)
)

(instance bedFeature of RFeature
	(properties
		y 140
		x 80
		heading 135
		nsTop 116
		nsLeft 44
		nsBottom 155
		nsRight 115
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/bed]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 61))
					((Said 'look<below') (PrintSeeNothing))
					((Said 'smell') (gEgo setScript: egoSitScript 0 1))
					((Said 'sit') (gEgo setScript: egoSitScript 0 8))
				)
			)
		)
	)
)

(instance leftCouch of RFeature
	(properties
		y 98
		x 100
		heading 90
		nsTop 74
		nsLeft 66
		nsBottom 111
		nsRight 85
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/couch]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 62))
					((proc954_0 self pEvent x y 0 6 7))
					((Said 'sit')
						(gEgo
							setScript: egoSitScript 0 (if (== x 215) 2 else 4)
						)
					)
					((Said 'smell') (Print 6 63))
					((Said 'feel') (Print 6 64))
				)
			)
		)
	)
)

(instance backCouchF of RFeature
	(properties
		y 74
		x 213
		heading 180
		nsTop 67
		nsLeft 183
		nsBottom 81
		nsRight 244
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/couch]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 62))
				)
			)
		)
	)
)

(instance egoSitScript of Script
	(properties)
	
	(method (changeState newState &tmp temp0)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo setAvoider: Avoid)
				(switch register
					(2
						(gEgo setMotion: MoveTo 215 98 self)
					)
					(4
						(gEgo setMotion: MoveTo 98 98 self)
					)
					(8
						(gEgo setMotion: MoveTo 129 140 self)
					)
					(1
						(gEgo setMotion: MoveTo 129 140 self)
					)
				)
			)
			(1
				(gEgo setAvoider: 0 illegalBits: 0)
				(switch register
					(2
						(gEgo setMotion: MoveTo 220 98 self)
					)
					(4
						(gEgo setMotion: MoveTo 92 98 self)
					)
					(8
						(gEgo setMotion: MoveTo 123 140 self)
					)
					(1
						(switch (Random 1 3)
							(1 (Print 6 65))
							(2 (Print 6 66))
							(3 (Print 6 67))
						)
						(HandsOn)
						(self dispose:)
					)
				)
			)
			(2
				(if (== register 2)
					(= temp0 (if (== (gEgo view?) 200) 3 else 6))
					(gEgo heading: 270)
				else
					(= temp0 (if (== (gEgo view?) 200) 2 else 5))
					(gEgo heading: 90)
				)
				(gEgo view: 106 setLoop: temp0 cel: 0 setCycle: End self)
			)
			(3 (User canInput: 1))
			(4 (gEgo setCycle: Beg self))
			(5
				(gEgo
					view: (if (or (== (gEgo loop?) 2) (== (gEgo loop?) 3))
						200
					else
						206
					)
					setCycle: Walk
				)
				(switch register
					(2
						(gEgo setLoop: 1 setMotion: MoveTo 215 98 self)
					)
					(4
						(gEgo setLoop: 0 setMotion: MoveTo 98 98 self)
					)
					(8
						(gEgo setLoop: 0 setMotion: MoveTo 129 140 self)
					)
				)
			)
			(6
				(gEgo setLoop: -1 illegalBits: -32768 setScript: 0)
				(HandsOn)
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'sit') (Print 6 68))
			((Said 'stand') (self cue:))
		)
	)
)

(instance rugFeature of RFeature
	(properties
		y 140
		x 240
		nsTop 120
		nsLeft 210
		nsBottom 160
		nsRight 270
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/carpet,carpet]>')
				(cond 
					((proc954_1 self pEvent 'look[<at,below]/*'))
					((Said 'look[<at,below]') (Print 6 69))
				)
			)
		)
	)
)

(instance windowFeature of RFeature
	(properties
		y 50
		x 100
		nsTop 15
		nsLeft 60
		nsBottom 68
		nsRight 135
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/shutter]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 70))
				)
			)
		)
	)
)

(instance lampFeature of RFeature
	(properties
		y 150
		x 20
		z 20
		nsTop 115
		nsLeft 10
		nsBottom 140
		nsRight 30
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/lamp]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 71))
				)
			)
		)
	)
)

(instance closetDoorFeature of RFeature
	(properties
		y 100
		x 275
		heading 270
		nsTop 73
		nsLeft 266
		nsBottom 131
		nsRight 283
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
				(or
					(Said 'wear,(change<in)/coat')
					(Said 'change/clothes')
				)
				(PrintDontNeed)
			)
			((Said '[/closet]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 72))
				)
			)
		)
	)
)

(instance oceanFeat of RFeature
	(properties
		y 55
		x 160
		nsTop 15
		nsLeft 60
		nsBottom 68
		nsRight 260
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/bay,water]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 6 73))
				)
			)
		)
	)
)

(instance floorFeature of Feature
	(properties
		y 109
		x 200
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/floor,floor]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at,down]') (Print 6 74))
				)
			)
		)
	)
)

(instance egoOpenDoorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(theSound number: (DecideSound 36) loop: 1 play: self)
			)
			(1
				(gRoom newRoom: (gRoom south?))
			)
		)
	)
)

(instance theSound of Sound
	(properties
		priority 2
	)
)
