;;; Sierra Script 1.0 - (do not remove this comment)
(script# 10)
(include sci.sh)
(use Main)
(use Class_255_0)
(use tahiti)
(use n316)
(use n361)
(use n824)
(use n828)
(use n954)
(use n958)
(use RFeature)
(use Extra)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	inLobby 0
)

(local
	local0
	local1
)
(instance inLobby of Rm
	(properties
		picture 10
		east 11
		south 9
		picAngle 70
		vanishingX 116
		vanishingY 36
	)
	
	(method (init)
		(super init:)
		(clerk init:)
		(doorToBar init:)
		(girlInLounge init:)
		(gAddToPics
			add: signPic picturePic barSignPic
			eachElementDo: #init
			doit:
		)
		(Load rsSOUND 42)
		(Load rsSOUND 36)
		(proc958_0 128 10 910 110 310)
		(gEgo init:)
		(self
			setRegions: 300
			setFeatures: flowersFeature plantFeature mailRFeat girlRFeature
		)
		(switch gPrevRoomNum
			(east
				(gEgo posn: 280 113 setMotion: MoveTo 200 113)
			)
			(else 
				(HandsOn)
				(gEgo posn: 116 176)
			)
		)
		(proc824_0)
		(proc316_0 gCurRoomNum 5)
	)
	
	(method (doit)
		(super doit:)
		(if (> (gEgo y?) 180) (self newRoom: south))
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room,scene,lobby]') (Print 10 0))
			((Said 'look<up') (Print 10 1))
		)
	)
	
	(method (cue)
		(super cue:)
		(self newRoom: 11)
	)
)

(instance signPic of RPicView
	(properties
		y 98
		x 174
		z 20
		view 10
		loop 3
		priority 4
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/sign,wall]>')
				(cond 
					((proc954_1 self pEvent 'read,look/*'))
					((Said 'read,look[<at]')
						(if (> (gEgo distanceTo: self) 60)
							(Print 10 2)
						else
							(signCloseUp init:)
						)
					)
				)
			)
		)
	)
)

(instance signCloseUp of View
	(properties
		y 58
		x 164
		view 310
	)
	
	(method (init)
		(super init:)
		(self setPri: 15)
		(= signal (& signal $feff))
		(gIceKeyDownHandler add: self)
		(proc828_0 tahiti 413 4 1)
	)
	
	(method (doit)
		(super doit:)
		(if (> (gEgo distanceTo: signPic) 60) (self dispose:))
	)
	
	(method (dispose)
		(gIceKeyDownHandler delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(if
			(or
				(== (pEvent type?) evMOUSEBUTTON)
				(== (pEvent type?) evKEYBOARD)
			)
			(self dispose:)
		)
	)
)

(instance picturePic of RPicView
	(properties
		y 124
		x 43
		z 30
		view 10
		loop 2
		priority 5
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/painting,(wall<left)]>')
				(cond 
					((proc954_1 self pEvent 'look/*'))
					((Said 'look[<at]') (Print 10 3))
				)
			)
		)
	)
)

(instance barSignPic of RPicView
	(properties
		y 139
		x 267
		z 28
		view 10
		loop 5
		priority 9
		signal $4000
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/sign,(wall<right)]>')
				(cond 
					((proc954_1 self pEvent 'look/*'))
					((Said 'look[<at]') (Print 10 4))
				)
			)
		)
	)
)

(instance doorToBar of Prop
	(properties
		y 120
		x 238
		view 10
		loop 4
	)
	
	(method (init)
		(super init:)
		(self ignoreActors: 1 setPri: 6 stopUpd:)
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(== (gEgo onControl: 1) 512)
				(not (self script?))
			)
			(HandsOff)
			(self setScript: barDoorScript)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door]>')
				(cond 
					((proc954_1 self pEvent 'look/*'))
					((Said 'look[<at]') (Print 10 5))
					((Said 'close') (Print 10 6))
					((proc954_0 self pEvent 229 115 'open' 10 7))
					((Said 'open') (return))
				)
			)
		)
	)
)

(instance barDoorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client setCycle: End self)
				(theSound number: (DecideSound 36) loop: 1 play:)
			)
			(1
				(if (> (gEgo x?) (client x?))
					(= register -1)
				else
					(= register 1)
				)
				(gEgo
					illegalBits: (if (== register 1) 0 else -32768)
					setMotion: MoveTo (+ (gEgo x?) (* 45 register)) (gEgo y?) self
				)
			)
			(2
				(gEgo illegalBits: -32768)
				(client setCycle: Beg self)
				(theSound number: (DecideSound 42) loop: 1 play:)
			)
			(3
				(if (== register 1)
					(HandsOn)
					(gRoom newRoom: 11)
				else
					(if (not (gRoom script?)) (HandsOn))
					(self dispose:)
				)
			)
		)
	)
)

(instance girlInLounge of Extra
	(properties
		y 164
		x 268
		view 10
		cycleType 2
		hesitation 15
		minPause 70
		maxPause 110
		minCycles 1
		maxCycles 1
	)
)

(instance girlRFeature of RFeature
	(properties
		y 167
		x 267
		nsTop 144
		nsLeft 257
		nsBottom 162
		nsRight 278
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/babe,cunt,boob][/table]>')
				(cond 
					((proc954_1 self pEvent 'look/*'))
					((Said 'look[<at]') (Print 10 8))
					((proc954_0 self pEvent self 40 0 10 7))
					((Said 'address') (Print 10 9))
					(
						(or
							(Said 'kiss')
							(Said '/kiss')
							(Said '//kiss')
							(Said 'ask/babe/date')
						)
						(Print 10 10)
					)
					((Said 'buy,order/drink[<babe][/babe]') (Print 10 11))
					((Said 'fuck,suck,hug') (Print 10 12))
				)
			)
		)
	)
)

(instance clerk of Act
	(properties
		y 106
		x 118
		z 20
		view 910
	)
	
	(method (init)
		(super init:)
		(self setPri: 6 stopUpd:)
		(if
			(and
				(& (tahiti flags?) $0008)
				(not (& (tahiti flags?) $0100))
			)
			(= local1 (Random 50 100))
		)
	)
	
	(method (doit)
		(super doit:)
		(if (and local1 (not (-- local1))) (self cue:))
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'ask,get/time') (Print 10 13))
			((Said '[/babe,babe,clerk,ya,cunt,boob]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]')
						(if (> (gEgo distanceTo: self) 30)
							(Print 10 14)
						else
							(proc361_0 110 eyesExtra lipsExtra)
						)
					)
					((proc954_0 self pEvent self 20 0 10 7))
					((Said 'fuck,suck') (Print 10 15))
					((Said '/cunt,boob') (Print 10 12))
					((Said 'address')
						(switch (Random 0 2)
							(0 (Print 10 16))
							(1 (Print 10 17))
							(2 (Print 10 18))
						)
						(proc828_0 tahiti 413 32 1)
					)
					((Said 'thank') (Print 10 19))
					(
						(or
							(Said 'kiss')
							(Said '/kiss')
							(Said '//kiss')
							(Said 'ask/babe/date')
						)
						(Print 10 20)
					)
					(
					(Said 'buy,order/drink[<babe,clerk][/babe,clerk]') (Print 10 21))
					(
						(or
							(Said 'get,call,dial,(pick<up)/call')
							(Said '(call<use)')
							(Said 'make/call<call')
							(Said '//call<about,for')
						)
						(Print 10 22)
					)
				)
			)
			(
			(proc954_1 self pEvent '[/headband,message,note]'))
			((Said 'look[<at]/headband') (Print 10 23))
			((Said '/message,note,mail>')
				(cond 
					((not (& (tahiti flags?) $0008)) (PrintDontNeed) (pEvent claimed: 1))
					((Said 'read,look[<at]')
						(if (& (tahiti flags?) $0100)
							(Print 10 24)
						else
							(pEvent claimed: 0)
						)
					)
					((proc954_1 self pEvent 'look[<at]/*'))
					((proc954_0 self pEvent self 20 0 10 7))
					((Said 'get,get')
						(cond 
							((& (tahiti flags?) $0100) (PrintAlreadyTookIt))
							(local0
								(Print 10 25)
								(gGame changeScore: 1)
								(tahiti flags: (| (tahiti flags?) $0100))
							)
							(else (pEvent claimed: 0))
						)
					)
				)
			)
			((or (Said '/bar') (Said '//bar')) (Print 10 26))
			((or (Said '/transport') (Said '//transport')) (Print 10 27))
			((Said 'get/information') (Print 10 28))
			((Said 'pay/bill,tab,room') (Print 10 29))
			((Said '//key<about,for')
				(if (proc316_1 gCurRoomNum 5)
					(self setScript: keyScript 0 0)
					(gEgo get: 5)
					(proc828_0 tahiti 413 2 1)
				else
					(PrintAlreadyTookIt)
				)
			)
			((Said '/key,room>')
				(cond 
					((proc954_0 self pEvent self 20 0 10 7))
					((Said 'get,get,rent,buy,need,reserve')
						(if (proc316_1 gCurRoomNum 5)
							(self setScript: keyScript 0 0)
							(gEgo get: 5)
							(proc828_0 tahiti 413 2 1)
						else
							(PrintAlreadyTookIt)
						)
					)
					((Said 'adjust,give,return,drop')
						(if (gEgo has: 5)
							(gEgo put: 5 gCurRoomNum)
							(self setScript: keyScript 0 1)
						else
							(PrintDontHave)
						)
					)
				)
			)
		)
	)
	
	(method (cue)
		(super cue: &rest)
		(if
			(and
				(not (& (tahiti flags?) $0100))
				(& (tahiti flags?) $0008)
			)
			(= local0 1)
			(Print 10 30 #time 10)
			(Print 10 31)
			(tahiti setScript: (ScriptID 300 2))
		)
	)
)

(instance keyScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register (Print 10 32))
				(clerk loop: 0 setCycle: End self)
			)
			(1 (= seconds 2))
			(2
				(clerk loop: 1 setCycle: End self)
			)
			(3
				(clerk loop: 0 cel: 0)
				(if (not register) (Print 10 33))
			)
		)
	)
)

(instance eyesExtra of Extra
	(properties
		y 83
		x 152
		view 110
		cycleType 2
		hesitation 10
		minPause 50
		maxPause 50
		minCycles 1
		maxCycles 1
	)
)

(instance lipsExtra of Extra
	(properties
		y 132
		x 155
		view 110
		loop 1
		cycleType 2
		hesitation 10
		minPause 50
		maxPause 50
		minCycles 1
		maxCycles 1
	)
)

(instance flowersFeature of RFeature
	(properties
		y 179
		x 227
		z 20
		nsTop 139
		nsLeft 217
		nsBottom 159
		nsRight 237
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/flower,centerpiece,table]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 10 34))
					((proc954_0 self pEvent self 50 0 10 7))
					((Said 'smell') (Print 10 35))
					((Said 'get') (Print 10 36))
				)
			)
		)
	)
)

(instance plantFeature of RFeature
	(properties
		y 101
		x 204
		nsTop 71
		nsLeft 194
		nsBottom 101
		nsRight 214
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/plant,fern]>')
				(cond 
					((proc954_1 self pEvent 'look/*'))
					((Said 'look[<at]') (Print 10 37))
					((proc954_0 self pEvent self 40 0 10 7))
					((Said 'move,get') (PrintDontNeed))
					((Said 'smell') (Print 10 38))
				)
			)
		)
	)
)

(instance mailRFeat of RFeature
	(properties
		y 65
		x 100
		nsTop 60
		nsLeft 84
		nsBottom 75
		nsRight 111
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			(
			(Said '[/cubbyhole,box,(wall<center,medium,rear)]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'check,look[<at]') (Print 10 39))
				)
			)
		)
	)
)

(instance theSound of Sound
	(properties
		priority 2
	)
)
