;;; Sierra Script 1.0 - (do not remove this comment)
(script# 1)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	openingScene 0
)

(local
	local0
)
(procedure (localproc_000c param1 &tmp [temp0 2] temp2 temp3 [temp4 100])
	(DisposePrintDlg)
	(Format @temp4 &rest)
	(TextSize @temp0 @temp4 gFont 0)
	(Print
		@temp4
		#at
		-1
		12
		#width
		(if (> temp2 24) 300 else 0)
		#mode
		1
		#dispose
		#time
		param1
	)
)

(instance openingScene of Rm
	(properties
		picture 1
	)
	
	(method (init)
		(HandsOff)
		(super init:)
		(self
			setScript: (if (== gPrevRoomNum 2) dinghyScript else openingScript)
			setRegions: 300 301
		)
		(miniActor1 init:)
		(miniActor2 init:)
		(miniActor3 init:)
	)
	
	(method (dispose)
		(HandsOn)
		(super dispose:)
	)
)

(instance openingScript of Script
	(properties)
	
	(method (init)
		(super init: &rest)
		(gIceKeyDownHandler add: self)
		(gIceMouseDownHandler add: self)
	)
	
	(method (dispose)
		(DisposePrintDlg)
		(gIceKeyDownHandler delete: self)
		(gIceMouseDownHandler delete: self)
		(super dispose: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(gAddToPics add: littleEgo doit:)
				(= seconds 10)
			)
			(1
				(localproc_000c 8 1 0)
				(= seconds 8)
			)
			(2
				(localproc_000c 8 1 1)
				(= seconds 8)
			)
			(3
				(localproc_000c 8 1 2)
				(= seconds 8)
			)
			(4
				(localproc_000c 8 1 3)
				(= seconds 8)
			)
			(5 (gRoom newRoom: 2))
		)
	)
	
	(method (cue)
		(= cycles (= seconds 0))
		(super cue:)
	)
	
	(method (handleEvent pEvent)
		(if (pEvent claimed?) (return) else (self cue:))
		(pEvent claimed: 1)
	)
)

(instance littleDinghy of Act
	(properties
		yStep 1
		view 1
		xStep 1
	)
	
	(method (init)
		(super init:)
		(boatSound number: (DecideSound 26) loop: -1 play:)
		(self setPri: 3)
	)
)

(instance dinghyScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(gEgo put: 5)
				(littleDinghy
					posn: 205 143
					init:
					setLoop: 0
					setCycle: Walk
					setMotion: MoveTo 100 152 self
				)
			)
			(1
				(littleDinghy setMotion: MoveTo -10 143 self)
			)
			(2 (= seconds 5))
			(3
				(littleDinghy
					posn: -10 92
					setLoop: 1
					setMotion: MoveTo 65 80 self
				)
			)
			(4
				(littleDinghy setMotion: MoveTo 120 72 self)
			)
			(5
				(HandsOn)
				(gRoom newRoom: 44)
			)
		)
	)
)

(instance littleEgo of PV
	(properties
		y 134
		x 211
		view 1
		loop 2
	)
)

(instance miniActor1 of Act
	(properties
		y 134
		x 171
		yStep 1
		view 1
		xStep 1
		moveSpeed 3
	)
	
	(method (init)
		(super init:)
		(self setLoop: 3 setMotion: MoveTo 229 138 self)
	)
	
	(method (cue)
		(super cue:)
		(if (== x 171)
			(self setMotion: MoveTo 229 138 self)
		else
			(self setMotion: MoveTo 171 134 self)
		)
	)
)

(instance miniActor2 of Act
	(properties
		y 135
		x 233
		yStep 1
		view 1
		loop 3
		xStep 1
		moveSpeed 3
	)
	
	(method (init)
		(super init:)
		(self setLoop: 3 setMotion: MoveTo 312 126 self)
	)
	
	(method (cue)
		(super cue:)
		(if (== x 233)
			(self setMotion: MoveTo 312 126 self)
		else
			(self setMotion: MoveTo 233 135 self)
		)
	)
)

(instance miniActor3 of Act
	(properties
		y 129
		x 204
		yStep 1
		view 1
		loop 3
		xStep 1
		moveSpeed 3
	)
	
	(method (init)
		(super init:)
		(self setLoop: 3 setMotion: MoveTo 203 141 self)
	)
	
	(method (cue)
		(super cue:)
		(if (== x 204)
			(self setMotion: MoveTo 203 141 self)
		else
			(self setMotion: MoveTo 204 129 self)
		)
	)
)

(instance boatSound of Sound
	(properties
		number 26
	)
)
