;;; Sierra Script 1.0 - (do not remove this comment)
(script# 20)
(include sci.sh)
(use Main)
(use Class_255_0)
(use n824)
(use n954)
(use n958)
(use Follow)
(use Chase)
(use Avoid)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	pentagonHall 0
)

(local
	local0
)
(instance pentagonHall of Rm
	(properties
		picture 20
	)
	
	(method (init)
		(super init: &rest)
		(self setRegions: 302)
		(proc958_0 128 20 120)
		(gAddToPics add: chair ashTray button1 button2 doit:)
		(proc824_0)
		(door init:)
		(elevator1 init:)
		((= local0 (Clone elevator1))
			signal: 16385
			posn: 31 108
			loop: 1
			init:
		)
		(guard init: loop: 3 setScript: guardScript)
		(gEgo init:)
		(if (!= gPrevRoomNum 21)
			(gEgo z: 1000 setScript: leavingElevator)
		else
			(gIceGlobalSound
				number: (DecideSound 67)
				priority: 1
				loop: -1
				play:
			)
			(gEgo posn: 309 83 setScript: exitBriefScript)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room]') (Print 20 0))
			((Said 'read/order')
				(if (== gPrevRoomNum 21)
					(Print 20 1)
				else
					(pEvent claimed: 0)
				)
			)
		)
	)
)

(instance exitBriefScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(door ignoreActors: 1 setCycle: End self)
			)
			(1
				(gEgo posn: 309 83 setMotion: MoveTo 309 93 self)
			)
			(2
				(door ignoreActors: 0 setCycle: Beg)
				(gEgo setMotion: MoveTo 309 109 self)
			)
			(3
				(gEgo ignoreActors: 0 illegalBits: -12288)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)

(instance elevator1 of Prop
	(properties
		y 96
		x 109
		view 20
		priority 5
		signal $4011
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/elevator]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 2))
					((Said 'open') (Print 20 3))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(self stopUpd:)
	)
)

(instance elevatorScript of Script
	(properties)
	
	(method (init)
		(= start 0)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (HandsOff) (= seconds 4))
			(1 (client setCycle: End self))
			(2
				(gEgo illegalBits: -32768 setAvoider: Avoid)
				(if register
					(gEgo setMotion: MoveTo 3 105 self)
				else
					(gEgo setMotion: MoveTo 118 93 self)
				)
			)
			(3
				(gEgo setAvoider: 0 heading: 180)
				((gEgo looper?) doit: gEgo (gEgo heading?))
				(= cycles 5)
			)
			(4 (client setCycle: Beg self))
			(5 (gRoom newRoom: 19))
		)
	)
)

(instance guard of Act
	(properties
		y 162
		x 112
		view 120
	)
	
	(method (init)
		(super init:)
		(self setCycle: Walk)
	)
	
	(method (handleEvent pEvent)
		(super handleEvent: pEvent)
		(cond 
			((super handleEvent: pEvent))
			((or (Said '/id,card>') (Said '//id,card>'))
				(cond 
					(
					(proc954_1 self pEvent 'examine,check,look[<at]/*'))
					((Said 'examine,check,look[<at]')
						(cond 
							(
							(and (gEgo has: 2) (== ((gInv at: 2) cel?) 1)) (Print 20 4))
							((gEgo has: 2) (Print 20 5))
							((== ((gInv at: 2) owner?) gCurRoomNum) (Print 20 6))
						)
					)
					((proc954_0 self pEvent self 20 0 20 7))
					((Said 'show,give')
						(cond 
							(
								(and
									(gEgo has: 2)
									(== ((gInv at: 2) cel?) 0)
									(== gPrevRoomNum 21)
								)
								(Print 20 8)
							)
							(
							(and (gEgo has: 2) (== ((gInv at: 2) cel?) 0))
								(Print 20 9)
								(Print 20 10)
								(gEgo put: 2 gCurRoomNum)
								(gGame changeScore: 1)
								(guard setMotion: MoveTo 112 166 guardScript)
								(HandsOn)
							)
							(
							(and (gEgo has: 2) (== ((gInv at: 2) cel?) 1))
								(Print 20 11)
								(Print 20 12)
								(Print 20 13)
								((gInv at: 2) cel: 0)
								(gGame changeScore: 1)
							)
							((== ((gInv at: 2) owner?) gCurRoomNum) (Print 20 14))
						)
					)
					(
						(or
							(Said 'get,get,return')
							(Said 'ask/guard')
							(Said 'ask/')
						)
						(cond 
							(
							(and (gEgo has: 2) (== ((gInv at: 2) cel?) 0)) (Print 20 15))
							(
							(and (gEgo has: 2) (== ((gInv at: 2) cel?) 1))
								(Print 20 16)
								(Print 20 12)
								(Print 20 17)
								((gInv at: 2) cel: 0)
								(gGame changeScore: 1)
							)
							(
							(and (not (gEgo has: 2)) (== gPrevRoomNum 21)) (Print 20 18) ((gInv at: 2) cel: 1) (gEgo get: 2))
							((not (gEgo has: 2)) (Print 20 19))
						)
					)
				)
			)
			((Said '[/guard,man]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 20))
					((proc954_0 self pEvent self 20 0 20 7))
					((Said 'address')
						(cond 
							(
								(and
									(!= gPrevRoomNum 21)
									(not (== ((gInv at: 2) owner?) gCurRoomNum))
								)
								(if (Random 0 1) (Print 20 21) else (Print 20 22))
							)
							((== gPrevRoomNum 21) (Print 20 23))
							(else (Print 20 24))
						)
					)
				)
			)
		)
	)
)

(instance guardScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(guard setMotion: Chase gEgo 25 self)
			)
			(2
				(Print 20 25)
				(gEgo setMotion: Follow guard 15)
				(= cycles 5)
			)
			(3 (HandsOn))
			(4
				(guard setMotion: MoveTo 112 162 guardScript)
			)
		)
	)
)

(instance door of Prop
	(properties
		y 86
		x 305
		view 20
		loop 4
	)
	
	(method (init)
		(super init:)
		(self stopUpd:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 26))
					((proc954_0 self pEvent self 20 0 20 7))
					((Said 'knock')
						(if (== gPrevRoomNum 21)
							(Print 20 27)
						else
							(Print 20 28)
						)
					)
					((Said 'open')
						(cond 
							((== gPrevRoomNum 21) (Print 20 29))
							((gEgo has: 2) (Print 20 30) (guard loop: 0))
							(else (self setScript: openDoorScript))
						)
					)
				)
			)
		)
	)
)

(instance openDoorScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(door setPri: 2 ignoreActors: 1 setCycle: End self)
			)
			(1
				(gEgo
					illegalBits: 0
					ignoreActors: 1
					setMotion: MoveTo 310 86 self
				)
			)
			(2 (gRoom newRoom: 21))
		)
	)
)

(instance ashTray of PV
	(properties
		y 105
		x 91
		view 20
		loop 3
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/ashtray]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 31))
					((Said 'use') (Print 20 32))
				)
			)
		)
	)
)

(instance chair of PV
	(properties
		y 108
		x 73
		view 20
		loop 2
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/chair]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 33))
					((Said 'sit') (Print 20 34))
				)
			)
		)
	)
)

(instance button1 of PV
	(properties
		y 78
		x 99
		z 1
		view 20
		loop 2
		cel 1
		priority 6
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/button]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 35))
					(
					(proc954_0 self pEvent self 30 'push,press' 20 7))
					((Said 'push,press') (Print 20 36) (elevator1 setScript: elevatorScript 0 0))
				)
			)
		)
	)
)

(instance button2 of PV
	(properties
		y 82
		x 43
		view 20
		loop 2
		cel 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/button]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 20 35))
					(
					(proc954_0 self pEvent self 30 'push,press' 20 7))
					((Said 'push,press') (Print 20 36) (local0 setScript: elevatorScript 0 1))
				)
			)
		)
	)
)

(instance leavingElevator of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (HandsOff) (= seconds 5))
			(1
				(if (> (gEgo x?) 159)
					(gEgo posn: 118 94 0)
					(elevator1 setCel: 0 setCycle: End self)
					(= register 1)
				else
					(gEgo posn: 13 104 0)
					(local0 setCel: 0 setCycle: End self)
					(= register 0)
				)
			)
			(2
				(elevator1 stopUpd:)
				(local0 stopUpd:)
				(gEgo
					setMotion: MoveTo (+ (gEgo x?) 4) (+ (gEgo y?) 24) self
				)
			)
			(3
				(gEgo observeControl: 20480)
				(if register
					(elevator1 setCycle: Beg self)
				else
					(local0 setCycle: Beg self)
				)
			)
			(4 (= seconds 1))
			(5
				(guardScript cue:)
				(= cycles 10)
			)
			(6
				(if register
					(elevator1 stopUpd:)
				else
					(local0 stopUpd:)
				)
				(self dispose:)
			)
		)
	)
)
