;;; Sierra Script 1.0 - (do not remove this comment)
(script# 19)
(include sci.sh)
(use Main)
(use Class_255_0)
(use n821)
(use n824)
(use n954)
(use n958)
(use Avoid)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	pentagonLobby 0
)

(local
	local0
	local1 =  1
)
(instance pentagonLobby of Rm
	(properties
		picture 19
		south 18
	)
	
	(method (init)
		(super init: &rest)
		(self setRegions: 302)
		(proc958_0 128 19 19)
		(gAddToPics
			add: eagle stars button1 ((Clone button1) x: 81)
			doit:
		)
		(proc824_0)
		(elevator1 init:)
		(elevator2 init:)
		(blip1 init: setPri: 8 setCycle: Fwd)
		(blip2 init: setPri: 8 setCycle: Fwd)
		(guard init: setPri: 7)
		(if (== gPrevRoomNum 20)
			(gEgo init: z: 1000 setScript: leavingPentagon)
			(= local0 1)
		else
			(gEgo init: posn: 155 180 heading: 0)
			(DirLoop gEgo 0)
			(gEgo
				observeControl: 16400
				setMotion: MoveTo 155 146
				setScript: noAdmitScript
			)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at,around][/room]') (Print 19 1) (Print 19 2))
		)
	)
	
	(method (newRoom newRoomNumber)
		(if (!= newRoomNumber 20) (Print 19 0))
		(super newRoom: newRoomNumber &rest)
	)
)

(instance noAdmitScript of Script
	(properties)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(not local0)
				(or
					(< (gEgo distanceTo: elevator1) 40)
					(< (gEgo distanceTo: elevator2) 40)
				)
				(== state 0)
			)
			(self cue:)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(switch (Random 0 2)
					(0 (Print 19 3) (Print 19 4))
					(1 (Print 19 5) (Print 19 6))
					(2 (Print 19 7))
				)
				(gEgo setMotion: 0 setAvoider: 0)
				(= cycles 1)
			)
			(2
				(HandsOff)
				(gEgo
					setMotion: MoveTo (gEgo x?) (+ (gEgo y?) 10) self
				)
			)
			(3 (HandsOn) (self init:))
		)
	)
)

(instance guard of View
	(properties
		y 121
		x 155
		z 1
		view 19
		loop 5
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'thank') (Print 19 8))
			((Said '[/guard,man]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 19 9))
					((proc954_0 self pEvent 156 128 'address' 19 10))
					((Said 'address')
						(cond 
							((== gPrevRoomNum 20) (Print 19 11))
							(local0 (Print 19 12))
							((Random 0 1) (Print 19 13))
							(else (Print 19 14))
						)
					)
				)
			)
			((Said '/room<briefing') (if local0 (Print 19 15) else (Print 19 16)))
			((Said '/id,card>')
				(cond 
					((proc954_1 self pEvent))
					((proc954_0 self pEvent 156 128 0 19 10))
					((Said 'show')
						(cond 
							((not (gEgo has: 2)) (proc821_0 918 0 0 19 17))
							(local0 (Print 19 18))
							((gEgo has: 2)
								(Print 19 19)
								(Print 19 20)
								(= local0 1)
								(gGame changeScore: 1)
								(gEgo setScript: 0)
							)
						)
					)
				)
			)
		)
	)
)

(instance elevatorScript of Script
	(properties)
	
	(method (init)
		(= start 0)
		(super init: &rest)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (HandsOff) (= seconds 4))
			(1
				(if register
					(elevator1 setCycle: End self)
				else
					(elevator2 setCycle: End self)
				)
			)
			(2
				(gEgo
					ignoreControl: 16400
					setAvoider: Avoid
					setMotion: MoveTo (if register 51 else 259) 86 self
				)
			)
			(3
				(gEgo setAvoider: 0 heading: 180)
				((gEgo looper?) doit: gEgo (gEgo heading?))
				(= cycles 5)
			)
			(4
				(if register
					(elevator1 setCycle: Beg self)
				else
					(elevator2 setCycle: Beg self)
				)
			)
			(5 (gRoom newRoom: 20))
		)
	)
)

(instance elevator1 of Prop
	(properties
		y 91
		x 71
		view 19
		priority 10
		signal $4001
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,elevator]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]'))
					((Said 'look') (Print 19 21))
					((Said 'open') (Print 19 22))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(self stopUpd:)
	)
)

(instance elevator2 of Prop
	(properties
		y 91
		x 239
		view 19
		loop 1
		priority 10
		signal $4001
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,elevator]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]'))
					((Said 'look') (Print 19 21))
					((Said 'open') (Print 19 22))
				)
			)
		)
	)
	
	(method (cue)
		(super cue:)
		(self stopUpd:)
	)
)

(instance button1 of PV
	(properties
		y 94
		x 224
		z 21
		view 19
		loop 2
		cel 2
		priority 6
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/button]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 19 23))
					((and (not local0) (Said 'push,press')) (Print 19 7))
					(
					(proc954_0 self pEvent self 20 'push,press' 19 10))
					((Said 'push,press')
						(if (== gPrevRoomNum 20)
							(Print 19 24)
							(Print 19 25)
						else
							(if local1 (= local1 0) (Print 19 26))
							(gRoom setScript: elevatorScript 0 (!= self button1))
						)
					)
				)
			)
		)
	)
)

(instance eagle of PV
	(properties
		y 74
		x 155
		view 19
		loop 2
		priority 6
	)
)

(instance stars of PV
	(properties
		y 35
		x 154
		view 19
		loop 2
		cel 1
		priority 6
	)
)

(instance blip1 of Prop
	(properties
		y 97
		x 101
		view 19
		loop 3
	)
)

(instance blip2 of Prop
	(properties
		y 98
		x 208
		view 19
		loop 4
	)
)

(instance leavingPentagon of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (HandsOff) (= seconds 5))
			(1
				(if (> (gEgo x?) 60)
					(gEgo posn: 264 84 0)
					(elevator2 setCel: 0 setCycle: End elevator2)
					(= register 1)
				else
					(gEgo posn: 48 84 0)
					(elevator1 setCel: 0 setCycle: End elevator1)
					(= register 0)
				)
				(= seconds 1)
			)
			(2
				(gEgo setMotion: MoveTo (gEgo x?) 145 self)
			)
			(3
				(gEgo observeControl: 16400)
				(if register
					(elevator2 setCycle: Beg self)
				else
					(elevator1 setCycle: Beg self)
				)
			)
			(4
				(if register
					(elevator2 stopUpd:)
				else
					(elevator1 stopUpd:)
				)
				(HandsOn)
				(self dispose:)
			)
		)
	)
)
