;;; Sierra Script 1.0 - (do not remove this comment)
(script# 305)
(include sci.sh)
(use Main)
(use Class_255_0)
(use RegionPath)
(use n821)
(use SmoothLooper)
(use Wander)
(use Sound)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	scubaRg 0
	proc305_1 1
	proc305_2 2
)

(local
	[local0 13] = [32767 57 249 110 340 110 32767 56 -20 133 150 150 -32768]
	[local13 27] = [32767 56 150 150 340 167 32767 55 -20 150 160 150 340 134 32767 53 -20 134 340 134 32767 54 -20 134 208 148 -32768]
	[local40 19] = [32767 54 208 148 340 155 32767 61 -20 157 340 140 32767 58 -20 140 31 140 -32768]
	[local59 47] = [32767 58 31 140 -20 105 32767 61 340 97 167 110 -20 118 32767 54 340 120 -20 88 32767 53 340 83 -20 81 32767 55 340 105 158 108 -20 125 32767 56 340 129 -20 131 32767 57 340 107 273 107 -32768]
	local106
	local107
	local108
)
(procedure (proc305_1 param1 param2 param3 param4 param5 &tmp newPV)
	((= newPV (PV new:))
		view: 56
		loop: param1
		cel: param2
		x: param3
		y: param4
	)
	(if (> argc 4) (newPV priority: param5))
	(gAddToPics add: newPV)
)

(procedure (proc305_2 param1 param2 param3 param4)
	((Clone wavingPlant)
		loop: param1
		x: param2
		y: param3
		setPri: param4
		init:
	)
)

(instance scubaRg of Rgn
	(properties)
	
	(method (init)
		(Load rsSOUND 58)
		(Load rsSOUND 258)
		(fish1 init:)
		(fish2 init:)
		(schoolOfFish init:)
		(super init:)
		(bubbles init:)
		(if (not local106)
			(= local106 1)
			(gIceGlobalSound
				number: 60
				priority: 1
				loop: -1
				play: egosBubbleScript
			)
		)
		(gEgo cycleSpeed: 2 setLoop: -1 setLoop: scubaLooper)
		(if (gEgo has: 6)
			(= local107 1)
			(gEgo view: 54)
			(scubaLooper vNormal: 54 vChangeDir: 55)
		else
			(= local107 5)
			(gEgo view: 154)
			(scubaLooper vNormal: 154 vChangeDir: 254)
		)
		(torpedoRay init: setScript: rayScript setCycle: Walk)
		(air init: ignoreActors: 1 setPri: 15)
		(if (<= (/ gNewQSnd 800) 0) (air hide:))
		(gauge init: ignoreActors: 1 setPri: 15 addToPic:)
		(super init:)
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(== (scubaLooper vNormal?) 54)
				(not (gEgo has: 6))
			)
			(scubaLooper vNormal: 154 vChangeDir: 254)
		)
		(if (< 0 gNewQSnd)
			(= gNewQSnd (- gNewQSnd local107))
			(if (< 0 (/ gNewQSnd 800))
				(air setCel: (- 10 (/ gNewQSnd 800)))
			else
				(air hide:)
			)
		else
			(proc821_0 157 0 1 305 0)
		)
		(switch local108
			(1 (proc821_0 157 0 1 305 1))
			(2 (proc821_0 157 0 0 305 2))
			(3 (proc821_0 157 0 1 305 3))
			(4 (proc821_0 157 0 1 305 3))
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'surface')
				(cond 
					((gEgo has: 6) (Print 305 4))
					(((gInv at: 4) ownedBy: 55) (Print 305 5))
					(else (Print 305 6))
				)
			)
			(
				(Said
					'examine,look[<at]/gear,scuba,coat,wetsuit,equipment'
				)
				(Print 305 7)
			)
			((Said 'look>')
				(cond 
					((Said '[<at,around][/room]')
						(switch (Random 0 3)
							(0 (Print 305 8))
							(1 (Print 305 9))
							(2 (Print 305 10))
							(3 (Print 305 11))
						)
					)
					((Said '/cave') (Print 305 12))
					((Said '/rock')
						(switch (Random 0 1)
							(0 (Print 305 13))
							(1 (Print 305 14))
						)
					)
					(else (Print 305 15) (pEvent claimed: 1))
				)
			)
			((Said 'get') (Print 305 16))
			((Said 'move>') (if (Said '/rock') (Print 305 17) else (Print 305 18)))
		)
	)
	
	(method (newRoom newRoomNumber)
		(= keep
			(proc999_5 newRoomNumber 53 54 55 56 57 58 61 45 46 47)
		)
		(= initialized 0)
		(if (!= ((gInv at: 3) owner?) 51)
			(= gCurRoomNum newRoomNumber)
			(= local108 1)
		)
		(if (proc999_5 newRoomNumber 999 70 71 72)
			(cond 
				((gEgo has: 6) (= gCurRoomNum newRoomNumber) (= local108 2))
				((== newRoomNumber 999) (= gCurRoomNum newRoomNumber) (= local108 3))
				((not ((gInv at: 4) ownedBy: 55)) (= gCurRoomNum newRoomNumber) (= local108 3))
				(else (gIceGlobalSound fade:) (gGame changeScore: 2))
			)
		)
	)
)

(instance egosBubbleScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0)
			(1
				(bubbles
					x:
						(switch (gEgo loop?)
							(0 (+ (gEgo x?) 8))
							(1 (- (gEgo x?) 8))
							(else  (gEgo x?))
						)
					y: (- (gEgo y?) 5)
					show:
					setPri: (gEgo priority?)
					setMotion: MoveTo (gEgo x?) 5 self
				)
			)
			(2
				(bubbles hide:)
				(= cycles 2)
			)
			(3 (self init:))
		)
	)
)

(instance bubbles of Act
	(properties
		yStep 3
		view 54
		loop 4
	)
	
	(method (init)
		(self
			setCycle: Walk
			setLoop: 4
			ignoreActors:
			illegalBits: 0
			setScript: egosBubbleScript
		)
		(super init:)
		(self hide:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/bubbles]') (Print 305 19))
		)
	)
)

(instance wavingPlant of Prop
	(properties
		view 56
		cycleSpeed 3
	)
	
	(method (init)
		(super init:)
		(self isExtra: 1 setCycle: Fwd)
	)
)

(instance fish1 of Act
	(properties
		view 57
	)
	
	(method (init)
		(super init:)
		(self
			xStep: 1
			yStep: 1
			posn: (Random 20 300) (Random 100 150)
			cycleSpeed: 2
			setCycle: Walk
			setMotion: Wander 100
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/fish]') (Print 305 20))
			((Said 'catch/fish') (Print 305 21))
			((Said 'kill/fish') (Print 305 22))
		)
	)
	
	(method (canBeHere)
		(if (super canBeHere:) (self inRect: -20 -20 340 210))
	)
)

(instance fish2 of Act
	(properties
		view 67
	)
	
	(method (init)
		(super init:)
		(self
			xStep: 1
			yStep: 1
			cycleSpeed: 2
			setCycle: Walk
			posn: (Random 20 300) (Random 70 150)
			setMotion: Wander 100
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/fish]') (Print 305 20))
			((Said 'catch/fish') (Print 305 21))
			((Said 'kill/fish') (Print 305 22))
		)
	)
	
	(method (canBeHere)
		(if (super canBeHere:) (self inRect: -20 -20 340 210))
	)
)

(instance scubaLooper of SmoothLooper
	(properties
		vNormal 54
		vChangeDir 55
	)
)

(instance schoolOfFish of Act
	(properties
		view 267
	)
	
	(method (init)
		(super init:)
		(self
			posn: (Random 0 320) (Random 0 200)
			setMotion: Wander 100
			setCycle: Fwd
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/fish]') (Print 305 23))
			((Said 'catch/fish') (Print 305 24))
			((Said 'kill/fish') (Print 305 22))
		)
	)
	
	(method (canBeHere)
		(if (super canBeHere:) (self inRect: -20 -20 340 210))
	)
)

(instance torpedoRay of Act
	(properties
		y 110
		x 259
		view 60
	)
	
	(method (init)
		(super init: &rest)
		(self ignoreControl: -32768 ignoreActors: 1)
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				mover
				(== (mover currentRoom?) gCurRoomNum)
				(< (gEgo distanceTo: self) 20)
			)
			(gEgo setMotion: MoveTo (gEgo x?) (gEgo y?))
			(HandsOff)
			(script register: 0)
			(self setMotion: 0 setScript: electricuteScript)
		)
	)
	
	(method (dispose)
		(= script 0)
		(super dispose:)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look[<at][/ray]') (Print 305 25))
			((Said 'catch/ray') (PrintNotCloseEnough))
		)
	)
)

(instance rayPath1 of RegionPath
	(properties
		endType 0
		theRegion 305
	)
	
	(method (at param1)
		(return [local0 param1])
	)
)

(instance rayPath2 of RegionPath
	(properties
		endType 0
		theRegion 305
	)
	
	(method (at param1)
		(return [local13 param1])
	)
)

(instance rayPath3 of RegionPath
	(properties
		endType 0
		theRegion 305
	)
	
	(method (at param1)
		(return [local40 param1])
	)
)

(instance rayPath4 of RegionPath
	(properties
		endType 0
		theRegion 305
	)
	
	(method (at param1)
		(return [local59 param1])
	)
)

(instance rayScript of Script
	(properties)
	
	(method (init)
		(if register
			(client script: self setMotion: register)
		else
			(super init: &rest)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(client
					setLoop: 3
					setCycle: Walk
					setMotion: rayPath1 self
				)
				(= register rayPath1)
			)
			(1
				(= register 0)
				(client setCel: 0 setLoop: 5 setCycle: End self)
			)
			(2
				(client setLoop: 4 setCycle: End self)
			)
			(3
				(client
					setLoop: 3
					setCycle: Walk
					setMotion: rayPath2 self
				)
				(= register rayPath2)
			)
			(4
				(= register 0)
				(client
					setLoop: 1
					setCel: 16
					cycleSpeed: 2
					setCycle: Beg self
				)
			)
			(5
				(client stopUpd:)
				(= seconds 10)
			)
			(6
				(client setLoop: 1 setCycle: End self)
			)
			(7
				(client
					setLoop: 3
					cycleSpeed: 0
					setCycle: Walk
					setMotion: rayPath3 self
				)
				(= register rayPath3)
			)
			(8
				(= register 0)
				(client setLoop: 1 cycleSpeed: 2 setCycle: Beg self)
			)
			(9
				(client stopUpd:)
				(= seconds 10)
			)
			(10
				(client setLoop: 1 setCycle: End self)
			)
			(11
				(client
					setLoop: 5
					cycleSpeed: 1
					setCel: 0
					setCycle: End self
				)
			)
			(12
				(client
					setLoop: 2
					setCycle: Walk
					setMotion: rayPath4 self
				)
				(= register rayPath4)
			)
			(13
				(client setLoop: 0 setCycle: Beg self)
				(= register 0)
			)
			(14 (= seconds 10))
			(15
				(client setLoop: 0 setCycle: End self)
			)
			(16
				(client setLoop: 4 setCel: 0 setCycle: End self)
			)
			(17 (self init:))
		)
	)
)

(instance electricGlow of Prop
	(properties
		view 159
	)
	
	(method (init param1 param2 param3)
		(super init:)
		(self
			posn: param1 param2
			setPri: param3
			ignoreActors: 1
			setCycle: End self
		)
	)
	
	(method (cue)
		(self setLoop: 1 setCycle: Fwd)
	)
)

(instance electricuteScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(zap number: (DecideSound 58) play:)
				((Clone electricGlow)
					init: (torpedoRay x?) (torpedoRay y?) (+ (torpedoRay priority?) 2)
				)
				(= cycles 15)
			)
			(1
				((Clone electricGlow)
					init: (gEgo x?) (gEgo y?) (+ (gEgo priority?) 2)
				)
				(= cycles 50)
			)
			(2 (proc821_0 951 2 0 305 26))
		)
	)
)

(instance gauge of Prop
	(properties
		y 11
		x 22
		z 1
		view 54
		loop 5
		priority 15
	)
)

(instance air of Prop
	(properties
		y 8
		x 5
		z 2
		view 54
		loop 6
		cel 9
	)
)

(instance zap of Sound
	(properties
		priority 2
	)
)
