;;; Sierra Script 1.0 - (do not remove this comment)
(script# 35)
(include sci.sh)
(use Main)
(use Class_255_0)
(use subMarine)
(use n821)
(use n954)
(use RFeature)
(use Cycle)
(use Game)
(use Feature)
(use Obj)

(public
	storageRm 0
)
(synonyms
	(compartment cabinet)
)

(local
	local0
)
(instance storageRm of Rm
	(properties
		picture 35
		east 42
		west 36
	)
	
	(method (init)
		(Load rsVIEW 35)
		(Load rsVIEW 935)
		(super init:)
		(HandsOn)
		(self
			setRegions: 314
			setFeatures:
				beansRF
				eggsRF
				milkRF
				meatRF
				applesRF
				potatoesRF
				flourRF
				greenBoxRF
				whiteBoxRF
				tpRF
				((Clone beansRF)
					nsLeft: 0
					nsRight: 23
					nsTop: 145
					nsBottom: 158
					yourself:
				)
				radiationSign
				therm
		)
		(door1 init: stopUpd:)
		(door2 init: stopUpd:)
		(scubaView
			init:
			cel: (if (== (subMarine suitRoom?) 38) 1 else 0)
		)
		(scubaDoorLeft init: stopUpd:)
		(scubaDoorRight init: stopUpd:)
		(radDoor init: stopUpd:)
		(switch gPrevRoomNum
			(36
				(gEgo
					view: 135
					illegalBits: 0
					posn: -22 103
					ignoreActors: 1
					init:
					setScript: fryToDeathScript
				)
			)
			(else 
				(gEgo
					posn: 245 102
					loop: 1
					heading: 90
					observeControl: 2
					init:
				)
			)
		)
	)
	
	(method (doit)
		(if (> (gEgo x?) 277)
			(self newRoom: east)
			(gEgo ignoreControl: 2)
		else
			(if (& (gEgo onControl: 0) $0002) (self newRoom: west))
			(super doit:)
		)
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said 'look>')
				(cond 
					((Said '[<around,in][/room,scene]') (Print 35 0))
					((Said '[<around,in][/freezer]') (Print 35 1))
					((Said 'box,provision') (Print 35 2))
					((Said 'soup,nut,food') (if local0 (Print 35 3) else (Print 35 4) (= local0 1)))
				)
			)
		)
	)
	
	(method (newRoom newRoomNumber)
		(if (not (gEgo script?))
			(super newRoom: newRoomNumber)
		)
	)
)

(instance fryToDeathScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(HandsOff)
				(radDoor setCycle: End self)
			)
			(1
				(Print 35 5)
				(gEgo setMotion: MoveTo 10 103 self)
			)
			(2
				(gEgo setMotion: MoveTo 30 108 self)
			)
			(3
				(gEgo setMotion: MoveTo 50 103 self)
			)
			(4
				(gEgo setMotion: MoveTo 70 108 self)
			)
			(5
				(gEgo setMotion: MoveTo 90 103 self)
			)
			(6
				(Print 35 6)
				(Print 35 7)
				(gEgo
					setLoop: 1
					setCel: 0
					cycleSpeed: 2
					setCycle: CT 3 1 self
				)
			)
			(7
				(gEgo cycleSpeed: 0 setCycle: End self)
			)
			(8
				(gEgo setLoop: 2 setCycle: Fwd)
				(= seconds 5)
			)
			(9 (proc821_0 337 3 0 35 8))
		)
	)
)

(instance eggsRF of RFeature
	(properties
		y 79
		x 100
		nsTop 68
		nsLeft 89
		nsBottom 91
		nsRight 112
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/egg]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 9))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance milkRF of RFeature
	(properties
		y 76
		x 101
		nsTop 48
		nsLeft 91
		nsBottom 67
		nsRight 112
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/milk]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 10))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance meatRF of RFeature
	(properties
		y 80
		x 214
		nsTop 70
		nsLeft 200
		nsBottom 91
		nsRight 228
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/pork,beef]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 11))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance applesRF of RFeature
	(properties
		y 37
		x 301
		nsTop 23
		nsLeft 283
		nsBottom 52
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/apple]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 12))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance beansRF of RFeature
	(properties
		y 174
		x 30
		nsTop 158
		nsBottom 190
		nsRight 61
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/bean]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 13))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance potatoesRF of RFeature
	(properties
		y 174
		x 129
		nsTop 159
		nsLeft 90
		nsBottom 190
		nsRight 168
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/potatoe]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 14))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance flourRF of RFeature
	(properties
		y 115
		x 284
		nsTop 94
		nsLeft 248
		nsBottom 137
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/flour]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 15))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance greenBoxRF of RFeature
	(properties
		y 129
		x 116
		nsTop 111
		nsLeft 79
		nsBottom 148
		nsRight 153
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/juice]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 16))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance whiteBoxRF of RFeature
	(properties
		y 130
		x 195
		nsTop 113
		nsLeft 154
		nsBottom 148
		nsRight 236
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/box]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 17))
					((Said 'get,open') (PrintDontNeed))
				)
			)
		)
	)
)

(instance tpRF of RFeature
	(properties
		y 74
		x 272
		nsTop 53
		nsLeft 225
		nsBottom 96
		nsRight 320
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/box]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 18))
					((Said 'get') (PrintDontNeed))
				)
			)
		)
	)
)

(instance door1 of Prop
	(properties
		y 94
		x 112
		view 35
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,freezer]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 19))
					((proc954_0 self pEvent 94 106 0 35 20))
					((Said 'open')
						(if (not cel)
							(self setCycle: End self)
						else
							(PrintItIs)
						)
					)
					((Said 'close') (if cel (self setCycle: Beg self) else (PrintItIs)))
				)
			)
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance door2 of Prop
	(properties
		y 94
		x 201
		view 35
		loop 1
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,freezer]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 21))
					((proc954_0 self pEvent 221 106 0 35 20))
					((Said 'open')
						(if (not cel)
							(self setCycle: End self)
						else
							(PrintItIs)
						)
					)
					((Said 'close') (if cel (self setCycle: Beg self) else (PrintItIs)))
				)
			)
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance scubaDoorLeft of Prop
	(properties
		y 95
		x 29
		view 35
		loop 3
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,closet,compartment,compartment]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]')
						(cond 
							((not cel) (Print 35 22))
							((== (subMarine suitRoom?) 38) (Print 35 23))
							(else (Print 35 24))
						)
					)
					((proc954_0 self pEvent 52 106 0 35 20))
					((Said 'open,unlock,(look<in)')
						(cond 
							(cel (PrintItIs))
							((gEgo has: 5)
								(Print 35 25)
								(self setCycle: End self)
								(scubaDoorRight setCycle: End scubaDoorRight)
								(if (!= (subMarine suitRoom?) 38)
									(willie
										illegalBits: 0
										init:
										setCycle: Walk
										setScript: willieScript
									)
									(gGame changeScore: 1)
								)
							)
							(else (Print 35 26))
						)
					)
					((Said 'close')
						(if cel
							(self setCycle: Beg self)
							(scubaDoorRight setCycle: Beg scubaDoorRight)
						else
							(PrintItIs)
						)
					)
				)
			)
			(
			(Said 'wear,get[/scuba,equipment,gear][/gear,equipment]')
				(cond 
					((not cel) (Print 35 27))
					((== (subMarine suitRoom?) 38) (Print 35 28))
					(else (Print 35 29))
				)
			)
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance scubaDoorRight of Prop
	(properties
		y 95
		x 74
		view 35
		loop 4
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance radDoor of Prop
	(properties
		y 103
		x 10
		view 935
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/door,reactor]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 30))
					((proc954_0 self pEvent 28 107 0 35 20))
					((Said 'open')
						(if (not cel)
							(self setCycle: End self)
							(gEgo ignoreControl: 2)
						else
							(PrintItIs)
						)
					)
					((Said 'close')
						(if cel
							(self setCycle: Beg self)
							(gEgo observeControl: 2)
						else
							(PrintItIs)
						)
					)
				)
			)
		)
	)
	
	(method (cue)
		(self stopUpd:)
	)
)

(instance scubaView of View
	(properties
		y 95
		x 51
		view 35
		loop 2
	)
)

(instance willie of Act
	(properties
		y 105
		x 275
		view 534
		loop 1
	)
)

(instance willieScript of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (HandsOff) (= seconds 3))
			(1
				(gEgo
					setMotion: MoveTo (gEgo x?) (+ (gEgo y?) 20) self
				)
				(willie setMotion: MoveTo 53 105 self)
			)
			(2
				(gEgo heading: 0)
				((gEgo looper?) doit: gEgo (gEgo heading?))
			)
			(3
				(Print 35 31)
				(willie view: 234 loop: 1)
				(scubaView setCel: 1)
				(subMarine suitRoom: 38)
				(= seconds 2)
			)
			(4
				(willie setMotion: MoveTo 164 105 self)
			)
			(5
				(gEgo
					setMotion: MoveTo (gEgo x?) (- (gEgo y?) 20) self
				)
				(willie setMotion: MoveTo 275 105 self)
			)
			(6
				(scubaDoorLeft setCycle: Beg scubaDoorLeft)
				(scubaDoorRight setCycle: Beg scubaDoorRight)
				(gEgo heading: 90)
				((gEgo looper?) doit: gEgo (gEgo heading?))
			)
			(7 (HandsOn) (willie dispose:))
		)
	)
)

(instance radiationSign of RFeature
	(properties
		y 106
		x 8
		z 40
		nsTop 54
		nsLeft 4
		nsBottom 62
		nsRight 12
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/sign,symbol]>')
				(cond 
					((proc954_1 self pEvent 'read,look[<at]/*'))
					((Said 'read,look[<at]') (Print 35 32))
				)
			)
		)
	)
)

(instance therm of RFeature
	(properties
		y 61
		x 149
		nsTop 55
		nsLeft 138
		nsBottom 67
		nsRight 160
	)
	
	(method (handleEvent pEvent)
		(cond 
			((super handleEvent: pEvent))
			((Said '[/thermometer,meter,gauge]>')
				(cond 
					((proc954_1 self pEvent 'look[<at]/*'))
					((Said 'look[<at]') (Print 35 33))
					((proc954_0 self pEvent 149 102 0 35 20))
					((Said 'read,check') (Print 35 34))
				)
			)
		)
	)
)
